<?php
// +-----------------------------------------------------------------------------+
// | evList A calendar solution for Geeklog                                      |
// | Date: Aug, 2007                                                             |
// +-----------------------------------------------------------------------------+
// | admin/index.php                                                             |
// +-----------------------------------------------------------------------------+
// | Copyright (C) 2007 by:                                                      |
// | evList Plugin Author:                                                       |
// | Alford Deeley - ajdeeley@summitpages.ca                                     |
// +-----------------------------------------------------------------------------+
// | Geeklog Common Code                                                         |
// | Copyright (C) 2000-2007 by the following authors:                           |
// | Authors: Tony Bibbs        - tony@tonybibbs.com                             |
// |          Mark Limburg      - mlimburg@users.sourceforge.net                 |
// |          Jason Whittenburg - jwhitten@securitygeeks.com                     |
// |          Dirk Haun         - dirk@haun-online.de                            |
// +-----------------------------------------------------------------------------+
// |                                                                             |
// | This program is licensed under the terms of the GNU General Public License  |
// | as published by the Free Software Foundation; either version 2              |
// | of the License, or (at your option) any later version.                      |
// |                                                                             |
// | This program is distributed in the hope that it will be useful,             |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        |
// | See the GNU General Public License for more details.                        |
// |                                                                             |
// | You should have received a copy of the GNU General Public License           |
// | along with this program; if not, write to the Free Software Foundation,     |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             |
// |                                                                             |
// +-----------------------------------------------------------------------------+

require_once('../../../lib-common.php');

if (!function_exists('evlist_hit')){
    //just refresh page to index
    print COM_refresh($_CONF['site_url']);
    exit;
}

if (!SEC_hasRights('evlist.edit')) {
    $display = COM_siteHeader ('menu', $LANG_EVLIST00[4]);
    $display .= COM_startBlock ($LANG_EVLIST00[4], '',
                        COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $LANG_EVLIST00[5];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("An anonymous user, {$_SERVER['REMOTE_ADDR']}, tried to illegally access the evList index page.");
    echo $display;
    exit;
}

function evlist_display_categories(){
    global $_CONF, $_TABLES, $LANG_EVLIST01;
    
    $t = new Template($_CONF['path'] . 'plugins/evlist/templates/');
    $t->set_file(array(
        'catadmin' => 'category_admin.thtml',
        'catrow' => 'category_row.thtml'
    ));
    
    $t->set_var(array(
        'action' => $_CONF['site_admin_url'] . '/plugins/evlist/category.php',
        'cid_label' => $LANG_EVLIST01[53],
        'name_label' => $LANG_EVLIST01[54],
        'enable_label' => $LANG_EVLIST01[55],
        'delete_label' => $LANG_EVLIST01[56],
        'createnew_label' => $LANG_EVLIST01[57],
        'update' => $LANG_EVLIST01[60],
        'cancel' => $LANG_EVLIST01[18],
        'reset' => $LANG_EVLIST01[16],
        'delete_note' => $LANG_EVLIST01[61],
        'disable_note' => $LANG_EVLIST01[65]
    ));
    
    $result = DB_query("SELECT * FROM {$_TABLES['evlist_categories']}");
    if (DB_numRows($result) > 0) {
        while ($A = DB_fetchArray($result)) {
            $t->set_var(array(
                'cid' => $A['id'],
                'name' => COM_stripslashes($A['name'])
            ));
            if ($A['status'] == '1') {
                $t->set_var('checked', ' checked="checked"');
            }
            $cssid = ($cssid ==1) ? 2: 1;
            $t->set_var('cssid', $cssid);
            $t->parse('category_row', 'catrow', true);
            $t->clear_var('checked');
        }
    }
    
    $t->parse ('output','catadmin');
    $retval .= $t->finish($t->get_var('output'));
    
    return $retval;
}

function evlist_update_all_categories($A){
    global $_CONF, $_TABLES;
    
    //return print_r($_POST);
    if (is_array($A['cats'])) {
        foreach ($A['cats'] as $key => $value) {
            //$key = category id
            //$value = category name
            $key = COM_applyFilter($key,true);
            
            if (!empty($key)) {
                if ($A['delete' . $key] != '1') {
                    
                    //update existing category
                    if (!empty($value)) {//deleting the text box content does nothing.
                        $name = addslashes (strip_tags (COM_checkWords ($value)));
                        $status = COM_applyFilter($A['enable'.$key],true);
                        $evStatus = COM_applyFilter($A['evenable'.$key],true);
                        
                        if (empty($status) || $status != '1') {
                            $status = '0';
                        }
                        evlist_update_one_category($key, $name, $status);
                    }
                } else {
                    //delete existing category
                    evlist_del_category($key);
                }
            }
        }
    }
    
    if (is_array($A['newcats'])) {
        foreach ($A['newcats'] as $key => $value) {
            $key = COM_applyFilter($key,true);
            if (!empty($key)) {
                //create new category
                if (!empty($value)) {//submitting and empty field is useless
                    $name = addslashes (strip_tags (COM_checkWords ($value)));
                    $status = COM_applyFilter($A['ncenable'.$key],true);
                    
                    if (empty($status) || $status != '1') {
                        $status = '0';
                    }
                    evlist_create_category($name, $status);
                }
            }
        }
    }
    
    $return_page = $_CONF['site_admin_url'] . '/plugins/evlist/category.php?msg=11';
    $retval = COM_refresh($return_page);
    
    return $retval;
}

function evlist_create_category($name, $status){
    global $_TABLES;
    DB_query("INSERT IGNORE INTO {$_TABLES['evlist_categories']} SET name = '$name', status = '$status'");
}

function evlist_update_one_category($cid, $name, $status){
    global $_TABLES;
    DB_query("UPDATE IGNORE {$_TABLES['evlist_categories']} SET name = '$name', status = '$status' WHERE id = '$cid' LIMIT 1");
    DB_query("UPDATE {$_TABLES['evlist_lookup']} SET status = '$status' WHERE cid = '$cid'");
}

function evlist_del_category($cid){
    global $_TABLES;
    DB_query("DELETE FROM {$_TABLES['evlist_categories']} WHERE id = '$cid' LIMIT 1");
    DB_query("DELETE FROM {$_TABLES['evlist_lookup']} WHERE cid = '$cid'");
}

/*
 * Main function
 */

if (isset($_REQUEST['msg'])){
    $msg = COM_applyFilter($_REQUEST['msg'], true);
} else $msg = '';

#if (isset ($_REQUEST['id'])) {
#    $cid = COM_applyFilter($_REQUEST['cid'], true);
#} else $cid = '';


$display = COM_siteHeader();

if (!empty($msg)) {
    //msg block
    $display .= COM_startBlock($LANG_EVLIST07[6],'','blockheader-message.thtml');
    $display .= $LANG_EVLIST07[$msg];
    $display .= COM_endBlock('blockfooter-message.thtml');
}

if ($_POST['submit'] == $LANG_EVLIST01[60]) { //save settings
    print evlist_update_all_categories($_POST);
    exit;
} elseif ($_POST['submit'] == $LANG_EVLIST01[18]) { //cancel
    print COM_refresh($_CONF['site_admin_url'] . '/plugins/evlist/index.php');
    exit;
} else { //display categories
    $display .= COM_startBlock();
    $display .= evlist_display_adminheader('categ');
    $display .= evlist_display_categories();
    $display .= COM_endBlock();
}

$display .= COM_siteFooter();

echo $display;

?>