<?php
// +-----------------------------------------------------------------------------+
// | evList A calendar solution for Geeklog                                      |
// | Date: Aug, 2007                                                             |
// +-----------------------------------------------------------------------------+
// | admin/index.php                                                             |
// +-----------------------------------------------------------------------------+
// | Copyright (C) 2007 by:                                                      |
// | evList Plugin Author:                                                       |
// | Alford Deeley - ajdeeley@summitpages.ca                                     |
// +-----------------------------------------------------------------------------+
// | Geeklog Common Code                                                         |
// | Copyright (C) 2000-2007 by the following authors:                           |
// | Authors: Tony Bibbs        - tony@tonybibbs.com                             |
// |          Mark Limburg      - mlimburg@users.sourceforge.net                 |
// |          Jason Whittenburg - jwhitten@securitygeeks.com                     |
// |          Dirk Haun         - dirk@haun-online.de                            |
// +-----------------------------------------------------------------------------+
// |                                                                             |
// | This program is licensed under the terms of the GNU General Public License  |
// | as published by the Free Software Foundation; either version 2              |
// | of the License, or (at your option) any later version.                      |
// |                                                                             |
// | This program is distributed in the hope that it will be useful,             |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        |
// | See the GNU General Public License for more details.                        |
// |                                                                             |
// | You should have received a copy of the GNU General Public License           |
// | along with this program; if not, write to the Free Software Foundation,     |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             |
// |                                                                             |
// +-----------------------------------------------------------------------------+

require_once('../../../lib-common.php');

if (!function_exists('evlist_hit')){
    //just refresh page to index
    print COM_refresh($_CONF['site_url']);
    exit;
}

if (!SEC_hasRights('evlist.edit')) {
    $display = COM_siteHeader ('menu', $LANG_EVLIST00[4]);
    $display .= COM_startBlock ($LANG_EVLIST00[4], '',
                        COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $LANG_EVLIST00[5];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("An anonymous user, {$_SERVER['REMOTE_ADDR']}, tried to illegally access the evList index page.");
    echo $display;
    exit;
}

function evlist_display_config() {
    global $_CONF, $_TABLES, $LANG_EVLIST01;
    
    $t = new Template($_CONF['path'] . 'plugins/evlist/templates/');
    $t->set_file('editor', 'config_editor.thtml');
    
    $t->set_var(array(
        'action' => $_CONF['site_url'] . '/admin/plugins/evlist/index.php?mode=config',
        'access_legend' => $LANG_EVLIST01[19],
        'gui_legend' => $LANG_EVLIST01[20],
        'centerblock_legend' => $LANG_EVLIST01[21],
        'anonview_label' => $LANG_EVLIST01[2],
        'anonadd_label' => $LANG_EVLIST01[3],
        'useradd_label' => $LANG_EVLIST01[4],
        'postmode_label' => $LANG_EVLIST01[5],
        'usermenu_label' => $LANG_EVLIST01[7],
        'menuitem_label' => $LANG_EVLIST01[8],
        'week_label' => $LANG_EVLIST01[9],
        'enablecb_label' => $LANG_EVLIST01[10],
        'position_label' => $LANG_EVLIST01[11],
        'topic_label' => $LANG_EVLIST01[12],
        'dateformat_label' => $LANG_EVLIST01[13],
        'timeformat_label' => $LANG_EVLIST01[14],
        'list_limit_label' => $LANG_EVLIST01[63],
        'block_limit_label' => $LANG_EVLIST01[62],
        'summ_limit_label' => $LANG_EVLIST01[64],
        'save' => $LANG_EVLIST01[15],
        'reset' => $LANG_EVLIST01[16],
        'cancel' => $LANG_EVLIST01[18],
        'defaults' => $LANG_EVLIST01[17],
        'submissions_note' => $LANG_EVLIST01[37],
        'postmode_note' => $LANG_EVLIST01[6],
        'menuitem_note' => $LANG_EVLIST01[22],
        'centerblock_note' => $LANG_EVLIST01[34],
        'range_label' => $LANG_EVLIST01[36],
        'limit_label' => $LANG_EVLIST01[35],
        'rem_status_label' => $LANG_EVLIST01[66],
        'eventpass_label' => $LANG_EVLIST01[68]
    ));
    
    //get current settings
    $result = DB_query("SELECT * FROM {$_TABLES['evlist_settings']}");
    $A = DB_fetchArray($result);
    
    $anonview_checked = ($A['allow_anon_view'] == '0') ? '' : ' checked="checked"';
    $anonadd_checked = ($A['allow_anon_add'] == '0') ? '' : ' checked="checked"';
    $useradd_checked = ($A['allow_user_add'] == '0') ? '' : ' checked="checked"';
    $postmode_checked = ($A['allow_html'] == '0') ? '' : ' checked="checked"';
    $menuitem_checked = ($A['enable_menuitem'] == '0') ? '' : ' checked="checked"';
    $rem_status_checked = ($A['enable_reminders'] == '0') ? '' : ' checked="checked"';
    if ($A['enable_reminders'] != '0') {
        $rem_status_checked = ' checked="checked"';
        $rem_note = $LANG_EVLIST01[67];
    } else {
        $rem_status_checked = '';
        $rem_note = '';
    }
    if ($A['enable_centerblock'] == '0') {
        $enabledcb_checked = '';
        $cboptions_show = ' style="display:none;"';
    } else {
        $enablecb_checked = ' checked="checked"';
        $cboptions_show = '';
    }
    
    $t->set_var(array(
        'anonview_checked' => $anonview_checked,
        'anonadd_checked' => $anonadd_checked,
        'useradd_checked' => $useradd_checked,
        'postmode_checked' => $postmode_checked,
        'menuitem_checked' => $menuitem_checked,
        'enablecb_checked' => $enablecb_checked,
        'rem_status_checked' => $rem_status_checked,
        'rem_note' => $rem_note,
        'cboptions_show' => $cboptions_show,
        'week_options' => evlist_getWeekStartOptions($A['week_begins']),
        'usermenu_options' => evlist_getUsermenuOptions($A['usermenu_option']),
        'position_options' => evlist_getPositionOptions($A['pos_centerblock']),
        'topic_options' => evlist_getTopicOptions(COM_stripslashes($A['topic_centerblock'])),
        'range_options' => evlist_getRangeOptions($A['range_centerblock']),
        'dateformat_options' => evlist_getDateFormatOptions($A['date_format']),
        'timeformat_options' => evlist_getTimeFormatOptions($A['time_format']),
        'limit' => $A['limit_centerblock'],
        'block_limit' => $A['limit_block'],
        'list_limit' => $A['limit_list'],
        'summ_limit' => $A['limit_summary'],
        'eventpass_options' => evlist_getEventPassingOptions($A['event_passing'])
    ));
    
    
    $t->parse('output', 'editor');
    $retval = COM_startBlock($LANG_EVLIST01[27]);
    $retval .= $t->finish($t->get_var('output'));
    $retval .= COM_endBlock();
    
    return $retval;
}

function evlist_apply_defaults() {
    global $_CONF, $_TABLES;
    
    //defaults as follows
    // 1 = allow anonymous access
    // 0 = deny anonymous submissions
    // 0 = deny user submissions
    // 1 = allow html in posts from users
    // 1 = 'add event' link in user menu
    // 1 = menuitem enabled
    // 1 = week begins on Sunday
    // 1 = date format = date("D M j, Y")
    // 1 = time format = date("g:i a")
    // 0 = centerblock disabled
    // 2 = centerblock position 'after featured story'
    // home = centerblock on homepage only
    // 2 = upcoming events in centerblock
    // 5 = event limit in centerblock
    // 5 = event limit in php block
    // 5 = event limit in main list
    // 128 = summary limit in centerblock
    // 1 = allow email reminders
    // 2 = event becomes past when start date has passed
    
    DB_query("UPDATE {$_TABLES['evlist_settings']} SET
        allow_anon_view = '1',
        allow_anon_add = '0',
        allow_user_add = '0',
        allow_html = '1',
        usermenu_option = '1',
        enable_menuitem = '1',
        week_begins = '1',
        date_format = '1',
        time_format = '1',
        enable_centerblock = '0',
        pos_centerblock = '2',
        topic_centerblock = 'home',
        range_centerblock = '2',
        limit_centerblock = '5',
        limit_block = '5',
        limit_list = '5',
        limit_summary = '128',
        enable_reminders = '1',
        event_passing = '2'
    ");
    
    //if the default for enable_reminders is changed to '0', then reminders must
    //be deleted from the rem_lookup table when defaults are applied--as follows:
    #DB_query("DELETE FROM {$_TABLES['evlist_remlookup']}");
    
    $retval = COM_refresh($_CONF['site_admin_url'] . '/plugins/evlist/index.php?mode=config&msg=7');
    
    return $retval;
}

function evlist_save_settings($A) {
    global $_CONF, $_TABLES;
    
    $A['anonview'] = COM_applyFilter($A['anonview'], true);
    $A['anonadd'] = COM_applyFilter($A['anonadd'], true);
    $A['useradd'] = COM_applyFilter($A['useradd'], true);
    if ($A['useradd'] == '0') {
        //You cannot enable anonadd if useradd is disabled..  that's just silly.
        $A['anonadd'] = '0';
    }
    $A['postmode'] = COM_applyFilter($A['postmode'], true);
    $A['usermenu'] = COM_applyFilter($A['usermenu'], true);
    $A['menuitem'] = COM_applyFilter($A['menuitem'], true);
    $A['week'] = COM_applyFilter($A['week'], true);
    $A['dateformat'] = COM_applyFilter($A['dateformat'], true);
    $A['timeformat'] = COM_applyFilter($A['timeformat'], true);
    $A['enablecb'] = COM_applyFilter($A['enablecb'], true);
    $A['position'] = COM_applyFilter($A['position'], true);
    $A['topic'] = COM_applyFilter($A['topic']);
    $A['range'] = COM_applyFilter($A['range'], true);
    $A['limit'] = COM_applyFilter($A['limit'], true);
    $A['list_limit'] = COM_applyFilter($A['list_limit'], true);
    $A['block_limit'] = COM_applyFilter($A['block_limit'], true);
    $A['summ_limit'] = COM_applyFilter($A['summ_limit'], true);
    $A['rem_status'] = COM_applyFilter($A['rem_status'], true);
    $A['eventpass'] = COM_applyFilter($A['eventpass'], true);
    
    DB_query("UPDATE {$_TABLES['evlist_settings']} SET
        allow_anon_view = '{$A['anonview']}',
        allow_anon_add = '{$A['anonadd']}',
        allow_user_add = '{$A['useradd']}',
        allow_html = '{$A['postmode']}',
        usermenu_option = '{$A['usermenu']}',
        enable_menuitem = '{$A['menuitem']}',
        week_begins = '{$A['week']}',
        date_format = '{$A['dateformat']}',
        time_format = '{$A['timeformat']}',
        enable_centerblock = '{$A['enablecb']}',
        pos_centerblock = '{$A['position']}',
        topic_centerblock = '{$A['topic']}',
        range_centerblock = '{$A['range']}',
        limit_centerblock = '{$A['limit']}',
        limit_list = '{$A['list_limit']}',
        limit_block = '{$A['block_limit']}',
        limit_summary = '{$A['summ_limit']}',
        enable_reminders = '{$A['rem_status']}',
        event_passing = '{$A['eventpass']}'
    ");
    
    if ($A['rem_status'] != '1') {
        DB_query("DELETE FROM {$_TABLES['evlist_remlookup']}");
    }
    
    $retval = COM_refresh($_CONF['site_admin_url'] . '/plugins/evlist/index.php?mode=config&msg=8');
    
    return $retval;
}

function evlist_list_events() {
    global $_CONF, $_TABLES, $_IMAGE_TYPE, $LANG_EVLIST01, $LANG_ADMIN;
    require_once( $_CONF['path_system'] . 'lib-admin.php' );
    
    $retval = '';
    
    $header_arr = array(      # dislay 'text' and use table field 'field'
                    array('text' => $LANG_EVLIST01[38], 'field' => 'edit', 'sort' => false),
                    array('text' => $LANG_EVLIST01[41], 'field' => 'copy', 'sort' => false),
                    array('text' => $LANG_EVLIST01[42], 'field' => 'id', 'sort' => true),
                    array('text' => $LANG_EVLIST01[39], 'field' => 'title', 'sort' => true),
                    array('text' => $LANG_EVLIST01[40], 'field' => 'date_start1', 'sort' => true),
                    array('text' => $LANG_EVLIST01[47], 'field' => 'status', 'sort' => true)
    );
    
    $defsort_arr = array('field' => 'date_start1', 'direction' => 'ASC');
    
    $menu_arr = array (
                    array('url' => $_CONF['site_url'] . '/evlist/event.php?op=new',
                          'text' => $LANG_EVLIST01[43]),
                    array('url' => $_CONF['site_admin_url'] . '/plugins/evlist/index.php?mode=config',
                          'text' => $LANG_EVLIST01[44]),
                    array('url' => $_CONF['site_admin_url'] . '/plugins/evlist/category.php',
                          'text' => $LANG_EVLIST01[51]),
                    array('url' => $_CONF['site_admin_url'],
                          'text' => $LANG_ADMIN['admin_home'])
    );
    
    $text_arr = array('has_menu'     => true,
                      'has_extras'   => true,
                      'title'        => $LANG_EVlIST01[45],
                      'instructions' => $LANG_EVLIST01[46],
                      'icon'         => $_CONF['site_url'] . '/evlist/images/evList.' . $_IMAGE_TYPE,
                      'form_url'     => $_CONF['site_admin_url'] . "/plugins/evlist/index.php",
                      'help_url'     => ''
    );
    
    $sql = "SELECT id, title, date_start1, status FROM {$_TABLES['evlist_events']} WHERE 1=1";

    $query_arr = array('table' => 'users',
                       'sql' => $sql,
                       'query_fields' => array('id', 'title', 'summary', 'full_description', 'location', 'date_start1', 'status')
    );

    $retval .= ADMIN_list ("evlist", "plugin_getListField_evlist", $header_arr, $text_arr,
                            $query_arr, $menu_arr, $defsort_arr);
    return $retval;
}

function evlist_status_change($eid) {
    global $_TABLES;
    
    if (DB_getItem($_TABLES['evlist_events'],"status", "id='$eid'")) {
        DB_query("UPDATE {$_TABLES['evlist_events']} set status = '0' WHERE id='$eid' LIMIT 1");
        return;
    } else {
        DB_query("UPDATE {$_TABLES['evlist_events']} set status = '1' WHERE id='$eid' LIMIT 1");
        return;
    }
}

/*
 * Main function
 */

if (isset($_REQUEST['msg'])){
    $msg = COM_applyFilter($_REQUEST['msg'], true);
} else $msg = '';

if (isset ($_REQUEST['mode'])) {
    $mode = COM_applyFilter($_REQUEST['mode']);
} else $mode = '';

if (isset ($_REQUEST['id'])) {
    $eid = COM_sanitizeID($_REQUEST['id'],false);
} else $eid = '';

if (isset ($_REQUEST['statusChange'])) {
    evlist_status_change(COM_sanitizeID($_REQUEST['statusChange'],false));
}

if ($mode == 'editsubmission') {
    print COM_refresh($_CONF['site_url'] . '/evlist/event.php?eid=' . $eid  . '&op=editsubmission');
    exit;
}

$display = COM_siteHeader();

if (!empty($msg)) {
    //msg block
    $display .= COM_startBlock($LANG_EVLIST07[6],'','blockheader-message.thtml');
    $display .= $LANG_EVLIST07[$msg];
    $display .= COM_endBlock('blockfooter-message.thtml');
}

if ($mode == 'config') {
    if ($_POST['submit'] == $LANG_EVLIST01[15]) { //save settings
        print evlist_save_settings($_POST);
        exit;
    } elseif ($_POST['submit'] == $LANG_EVLIST01[18]) { //cancel
        print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
        exit;
    } elseif ($_POST['submit'] == $LANG_EVLIST01[17]) { //apply defaults
        print evlist_apply_defaults();
        exit;
    } else { //display config editor
        $display .= COM_startBlock();
        $display .= evlist_display_adminheader('config');
        $display .= evlist_display_config();
        $display .= COM_endBlock();
    }
} else {
    $display .= evlist_list_events();
}

$display .= COM_siteFooter();

echo $display;

?>