<?php
// +-----------------------------------------------------------------------------+
// | evList A calendar solution for Geeklog                                      |
// | Date: Aug, 2007                                                             |
// +-----------------------------------------------------------------------------+
// | event.php                                                                   |
// +-----------------------------------------------------------------------------+
// | Copyright (C) 2007 by:                                                      |
// | evlist Plugin Author:                                                       |
// | Alford Deeley - ajdeeley@summitpages.ca                                     |
// +-----------------------------------------------------------------------------+
// | Geeklog Common Code                                                         |
// | Copyright (C) 2000-2007 by the following authors:                           |
// | Authors: Tony Bibbs        - tony@tonybibbs.com                             |
// |          Mark Limburg      - mlimburg@users.sourceforge.net                 |
// |          Jason Whittenburg - jwhitten@securitygeeks.com                     |
// |          Dirk Haun         - dirk@haun-online.de                            |
// +-----------------------------------------------------------------------------+
// |                                                                             |
// | This program is licensed under the terms of the GNU General Public License  |
// | as published by the Free Software Foundation; either version 2              |
// | of the License, or (at your option) any later version.                      |
// |                                                                             |
// | This program is distributed in the hope that it will be useful,             |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        |
// | See the GNU General Public License for more details.                        |
// |                                                                             |
// | You should have received a copy of the GNU General Public License           |
// | along with this program; if not, write to the Free Software Foundation,     |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             |
// |                                                                             |
// +-----------------------------------------------------------------------------+

require_once('../lib-common.php');

if (!function_exists('evlist_hit')){
    //just refresh page to index
    print COM_refresh($_CONF['site_url']);
    exit;
}

if (DB_getItem($_TABLES['evlist_settings'], 'allow_anon_view') != '1' && $_USER['uid'] < 2) {
    $display = COM_siteHeader ('menu', $LANG_EVLIST00[4]);
    $display .= COM_startBlock ($LANG_EVLIST00[4], '',
                        COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $LANG_EVLIST00[5];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("An anonymous user, {$_SERVER['REMOTE_ADDR']}, tried to illegally access the evList index page.");
    echo $display;
    exit;
}

function evlist_display_event($eid, $timestamp = '') {
    global $_CONF, $_TABLES, $LANG_EVLIST03, $LANG_EVLIST12;
    
    $retval = '';
    $retval .= COM_startBlock($LANG_EVLIST03[1]);
    $result = evlist_single_event_query($eid);
    
    if (empty($result)) {
        //eid doesn't exist msg
        $retval .= sprintf($LANG_EVLIST03[2], $eid);
    } else {
        //display event
        
        $A = DB_fetchArray($result);
        
        $Sresult = DB_query("SELECT week_begins, enable_reminders FROM {$_TABLES['evlist_settings']}");
        $S = DB_fetchArray($Sresult);
        
        //update hit count
        evlist_hit($eid);
        
        $t = new Template($_CONF['path'] . 'plugins/evlist/templates/');
        $t->set_file(array(
            'event' => 'event.thtml',
            'editlinks' => 'edit_links.thtml',
            'datetime' => 'date_time.thtml',
            'address' => 'address.thtml',
            'contact' => 'contact.thtml'
        ));
        
        // If plain text then replace newlines with <br> tags
        if( $A['postmode'] == '1' ) {//plaintext
            $A['summary'] = nl2br($A['summary']);
            $A['full_description'] = nl2br($A['full_description']);
            $A['location'] = nl2br($A['location']);
        }
        $title = COM_stripslashes($A['title']);
        $summary = PLG_replaceTags(COM_stripslashes($A['summary']));
        $fulldescription = PLG_replaceTags(COM_stripslashes($A['full_description']));
        
        $t->set_var(array(
            'title' => $title,
            'summary' => $summary,
            'full_description' => $fulldescription
        ));
        
        # check for $timestamp here and supply the appropriate dates.
        # timestamp represents the interval between the original and the new start date.
        # you are viewing a recurrence of an event so dates will not be as original.
        # add the diff between date_start1 and timestamp to the other dates
        if (!empty($timestamp)) {
            $timediff = $timestamp - strtotime($A['date_start1']);
            $A['date_start1'] = evlist_displayFormatedDate($timestamp);
            $A['date_end1'] = (!empty($A['date_end1']) && $A['date_end1'] != '0000-00-00') ? evlist_displayFormatedDate(strtotime($A['date_end1']) + $timediff) : '';
            $A['date_start2'] = (!empty($A['date_start2']) && $A['date_start2'] != '0000-00-00') ? evlist_displayFormatedDate(strtotime($A['date_start2']) + $timediff) : '';
            $A['date_end2'] = (!empty($A['date_end2']) && $A['date_end2'] != '0000-00-00') ? evlist_displayFormatedDate(strtotime($A['date_end2']) + $timediff) : '';
        } else {
            $A['date_start1'] = evlist_displayFormatedDate(strtotime($A['date_start1']));
            $A['date_end1'] = (!empty($A['date_end1']) && $A['date_end1'] != '0000-00-00') ? evlist_displayFormatedDate(strtotime($A['date_end1'])) : '';
            $A['date_start2'] = (!empty($A['date_start2']) && $A['date_start2'] != '0000-00-00') ? evlist_displayFormatedDate(strtotime($A['date_start2'])) : '';
            $A['date_end2'] = (!empty($A['date_end2']) && $A['date_end2'] != '0000-00-00') ? evlist_displayFormatedDate(strtotime($A['date_end2'])) : '';
        }
        
        if (!empty($A['date_start1']) && $A['date_start1'] != '0000-00-00') {
            //$datestart1 = evlist_displayFormatedDate(strtotime($A['date_start1']));
            $datestart1 = $LANG_EVLIST03[3] . $A['date_start1'];
            if (!empty($A['time_start1'])) {
                $timestart1 = ', ' . evlist_displayFormatedTime(strtotime($A['time_start1']));
            } else {
                $timestart1 = '';
            }
            if ($A['allday'] == '1') {
                $allday = '<br />' . $LANG_EVLIST03[14];
            } else {
                $allday = '';
            }
            if ($A['recurring'] == '1') {
                $every = array(1 => $LANG_EVLIST03[17], 2 => $LANG_EVLIST03[18],
                    3 => $LANG_EVLIST03[19], 4 => $LANG_EVLIST03[20], 5 => $LANG_EVLIST03[18]);
                switch ($A['rec_option']) {
                case 1:
                case 2:
                case 3:
                case 5:
                    $recurring = '<br />' . sprintf($LANG_EVLIST03[15], $every[$A['rec_option']]);
                    break;
                case 4:
                    $weekstart = $S['week_begins'];//DB_getItem($_TABLES['evlist_settings'], 'week_begins');
                    if ($weekstart == 1) {
                        $weekdaysA = array(1 => $LANG_EVLIST12[1]);
                    } else {
                        $weekdaysA = array(0 => $LANG_EVLIST12[1]);
                    }
                    array_push($weekdaysA, $LANG_EVLIST12[2], $LANG_EVLIST12[3], $LANG_EVLIST12[4],
                        $LANG_EVLIST12[5], $LANG_EVLIST12[6], $LANG_EVLIST12[7]);
                    $daynumsA = explode(";", $A['rec_data']);
                    $daynumsA = explode(",", $daynumsA[0]);
                    $daycount = count($daynumsA);
                    $weekdays = '';
                    for ($i = 0; $i < $daycount; $i++) {
                        if (!empty($daynumsA[$i])) {
                            if ($i == $daycount - 1) {
                                if ($daycount > 0 ) {
                                    $weekdays .= $LANG_EVLIST03[21];
                                }
                                $weekdays .= $weekdaysA[$daynumsA[$i]];
                            } else {
                                $weekdays .= $weekdaysA[$daynumsA[$i]] . ', ';
                            }
                        }
                    }
                    $recurring = '<br />' . sprintf($LANG_EVLIST03[15], sprintf($every[$A['rec_option']], $weekdays));
                    break;
                #case 6:
                #    $recurring = '<br />' . sprintf();
                #    break;
                }
            } else {
                $recurring = '';
            }
        } else {
            //of course this should never happen cuz ds1 is now required
            $datestart1 = '';
        }
        if (!empty($A['date_end1']) && $A['date_end1'] != '0000-00-00') {
            //$dateend1 = evlist_displayFormatedDate(strtotime($A['date_end1']));
            $dateend1 = '<br />' . $LANG_EVLIST03[4] . $A['date_end1'];
            if (!empty($A['time_end1'])) {
                $timeend1 = ', ' . evlist_displayFormatedTime(strtotime($A['time_end1']));
            } else {
                $timeend1 = '';
            }
        } else {
            $dateend1 = '';
        }
        if (!empty($A['date_start2']) && $A['date_start2'] != '0000-00-00') {
            //$datestart2 = evlist_displayFormatedDate(strtotime($A['date_start2']));
            $datestart2 = '<br />' . $LANG_EVLIST03[3] . $A['date_start2'];
            if (!empty($A['time_start2'])) {
                $timestart2 = ', ' . evlist_displayFormatedTime(strtotime($A['time_start2']));
            } else {
                $timestart2 = '';
            }
        } else {
            $datestart2 = '';
        }
        if (!empty($A['date_end2']) && $A['date_end2'] != '0000-00-00') {
            //$dateend2 = evlist_displayFormatedDate(strtotime($A['date_end2']));
            $dateend2 = '<br />' . $LANG_EVLIST03[4] . $A['date_end2'];
            if (!empty($A['time_end2'])) {
                $timeend2 = ', ' . evlist_displayFormatedTime(strtotime($A['time_end2']));
            } else {
                $timeend2 = '';
            }
        } else {
            $dateend2 = '';
        }
        
        $t->set_var(array(
            'begin_label' => $LANG_EVLIST03[3],
            'end_label' => $LANG_EVLIST03[4],
            'start_datetime1' => $datestart1 . $timestart1,
            'end_datetime1' => $dateend1 . $timeend1,
            'start_datetime2' => $datestart2 . $timestart2,
            'end_datetime2' => $dateend2 . $timeend2,
            'allday_event' => $allday,
            'recurring_event' => $recurring
        ));
        
        if (!empty($datestart1) || !empty($dateend1) || !empty($datestart1) || !empty($dateend2)) {
            $t->parse('datetime_info', 'datetime');
        }
        
        if (!empty($A['url'])) {
            $url = '<a href="' . COM_stripslashes($A['url']) . '">' . $LANG_EVLIST03[13] . '</a>' . '<br />';
        }
        if (!empty($A['location'])) {
            $location = COM_stripslashes($A['location']) . '<br />';
        }
        if (!empty($A['street'])) {
            $street = COM_stripslashes($A['street']) . '<br />';
        }
        if (!empty($A['city'])) {
            $city = COM_stripslashes($A['city']);
            if (!empty($A['province'])) {
                $province = ',&nbsp;' . COM_stripslashes($A['province']) . '<br />';
            } else {
                $city = $city . '<br />';
                $province = '';
            }
        } else {
            $city = '';
            if (!empty($A['province'])) {
                $province = COM_stripslashes($A['province']) . '<br />';
            } else {
                $province = '';
            }
        }
        if (!empty($A['postal'])) {
            $postal = COM_stripslashes($A['postal']) . '<br />';
        } else {
            $postal = '';
        }
        if (!empty($A['country'])) {
            $country = COM_stripslashes($A['country']);
        } else {
            $country = '';
        }
        
        if (!empty($url) || !empty($location) || !empty($street) || !empty($city) || !empty($province) || !empty($postal)) {
            $t->set_var(array(
                'location_label' => $LANG_EVLIST03[12],
                'url' => $url,
                'location' => $location,
                'street' => $street,
                'city' => $city,
                'province' => $province,
                'country' => $country,
                'postal' => $postal
            ));
            $t->parse('address_info', 'address');
        }
        
        //put contact info here: contact, email, phone#
        if (!empty($A['contact'])) {
            $name = '<br />' . COM_applyFilter($A['contact']);
        }
        if (!empty($A['email'])) {
            $email = COM_applyFilter($A['email']);
            $email = '<br />' . evlist_display_email($email);
        }
        if (!empty($A['phone'])) {
            $phone = '<br />' . COM_applyFilter($A['phone']);
        }
        
        if (!empty($name) || !empty($email) || !empty($phone)) {
            $t->set_var(array(
                'contact_label' => $LANG_EVLIST03[16],
                'name' => $name,
                'email' => $email,
                'phone' => $phone
            ));
            $t->parse('contact_info', 'contact');
        }
        
        if (!empty($range)) {
            $andrange = '&range=' . $range;
        } else $andrange = '&range=2';
        
        if (!empty($cat)) {
            $andcat = '&cat=' . $cat;
        } else $andcat = '';
        
        //category info here
        $cresult = DB_query("SELECT id, name FROM {$_TABLES['evlist_categories']} tc
            LEFT JOIN {$_TABLES['evlist_lookup']} tl ON id = cid WHERE eid = '$eid' AND tl.status = '1'");
        $catcount = DB_numRows($cresult);
        if ($catcount >= 1) {
            $t->set_file('category_links', 'category_links.thtml');
            $t->set_var('catmore', $LANG_EVLIST03[23]);
            $i = 1;
            while ($C = DB_fetchArray($cresult)) {
                $catlink = '<a href="';
                $catlink .= COM_buildURL($_CONF['site_url'] . '/evlist/index.php?op=list' . $andrange . '&cat=' . $C['id']);
                $catlink .= '">' . COM_stripslashes($C['name']) . '</a>&nbsp;';
                if ($i < $catcount) {
                    $catlink .= '|&nbsp;';
                }
                $t->set_var('category_link', $catlink, true);
                $i++;
            }
            $t->parse('categories', 'category_links');
        }
        
        //reminders must be enabled globally first and then per event in order to be active
        if ($S['enable_reminders'] == '1' && $A['enable_reminders'] == '1' && strtotime("now") < strtotime("-7 days", strtotime($A['date_start1']))) {
            //form will not appear within 7 days of scheduled event.
            
            if (empty($timestamp)) {
                $timestamp = '0';
            }
            
            $t->set_file('rem_form', 'reminder_form.thtml');
            $t->set_var(array(
                'action' => $_CONF['site_url'] . '/evlist/event.php',
                'eid' => $eid,
                'timestamp' => $timestamp,
                'email_label' => $LANG_EVLIST03[24],
                'notice_label' => $LANG_EVLIST03[28],
                'rem_note' => $LANG_EVLIST03[25],
                'email_note' => $LANG_EVLIST03[26],
                'submit' => $LANG_EVLIST03[27]
            ));
            $t->parse('reminder', 'rem_form');
        }
        
        $ownerlink = $_CONF['site_url'] . '/profiles.php?uid=' . $A['owner_id'];
        $ownerlink = '<a href="' . $ownerlink . '">' . $LANG_EVLIST03[7] . '</a>';
        $ownerlink = sprintf($LANG_EVLIST03[5], $ownerlink);
        
        $backlink = COM_buildURL($_CONF['site_url'] . '/evlist/index.php?op=list' . $andrange . $andcat);
        $backlink = '<a href="' . $backlink . '">' . $LANG_EVLIST03[10] . '</a>';
        
        $t->set_var(array(
            'owner_link' => $ownerlink,
            'back_link' => $backlink
        ));
            
        //display delete and edit links
        if (SEC_hasRights('evlist.edit')) {
            $editlink = $_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&op=edit';
            $editlink = '<a href="' . $editlink . '">' . $LANG_EVLIST03[8] . '</a>';
            $t->set_var('edit_link', $editlink);
            $deletelink = $_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&op=del';
            $deletelink = '<a href="' . $deletelink . '">' . $LANG_EVLIST03[9] . '</a>';
            $t->set_var('delete_link', $deletelink);
            $t->parse ('edit_links','editlinks');
        }
        
        $t->parse ('output','event');
        $retval .= $t->finish($t->get_var('output'));
    }
    
    $retval .= COM_endBlock();
    return $retval;
}

function evlist_display_editor($eid = '', $clone = false, $submission = false) {
    global $_CONF, $_TABLES, $_USER, $LANG_EVLIST03, $LANG_EVLIST04;
    
    $retval = '';
    $hour_mode = '24';//get this from the db???  i think people can handle 24.
    $retval .= COM_startBlock($LANG_EVLIST04[1]);
    $t = new Template($_CONF['path'] . 'plugins/evlist/templates/');
    $t->set_file(array(
        'editor' => 'editor.thtml',
        'perms' => 'edit_perms.thtml',
        'del_option' => 'del_option.thtml',
        'edit_postmode' => 'edit_postmode.thtml',
        'status' => 'status.thtml',
        'rem_status' => 'reminder_status.thtml',
        'category_set' => 'category_options.thtml',
        'category' => 'category_item.thtml'
    ));
    
    $Sresult = DB_query("SELECT allow_html, enable_categories, enable_reminders FROM {$_TABLES['evlist_settings']}");
    $S = DB_fetchArray($Sresult);
    
    if (!empty($eid)) {
        //edit or clone and edit existing event
        //load data into editor
        
        $result = evlist_single_event_query($eid);
        
        if (empty($result)) {
            //eid doesn't exist msg
            $retval .= sprintf($LANG_EVLIST03[2], $eid);
        } else {
            $A = DB_fetchArray($result);
            
            if ($clone) {
                $eid = '';
            }
            
            if ($submission) {
                $subInput = '<input type="hidden" name="submission" value="1" />';
                $t->set_var('submission', $subInput);
            }
            
            $t->set_var(array(
                'eid' => $eid,
                'title' => COM_stripslashes($A['title'])
            ));
            
            if ((SEC_hasRights('evlist.edit') || ($S['allow_html'] == '1' && $_USER['uid'] > 1)) && $A['postmode'] == '2') {
                $postmode = '2';//html
            } else {
                $postmode = '1';//plaintext
            }
            
            if ($postmode == '2') {//html
                $t->set_var(array(
                    'summary' => COM_stripslashes($A['summary']),
                    'description' => COM_stripslashes($A['full_description']),
                    'location' => COM_stripslashes($A['location'])
                ));
            } elseif ($postmode == '1') {//plaintext
                $t->set_var(array(
                    'summary' => COM_undoClickableLinks (COM_undoSpecialChars (COM_stripslashes($A['summary']))),
                    'description' => COM_undoClickableLinks (COM_undoSpecialChars (COM_stripslashes($A['full_description']))),
                    'location' => COM_undoClickableLinks (COM_undoSpecialChars (COM_stripslashes($A['location'])))
                ));
            }
            
            if ($A['status'] == '1') {
                $status_checked = ' checked="checked"';
            } else {
                $status_checked = '';
            }
            
            //date/time info
            if (!empty($A['date_start1']) && $A['date_start1'] != '0000-00-00') {
                $date_start1 = strtotime($A['date_start1']);
                $startday1 = strftime("%d", $date_start1);
                $startmonth1 = strftime("%m", $date_start1);
                $startyear1 = strftime("%Y", $date_start1);
                
                //no time if no date
                if (!empty($A['time_start1'])) {
                    $time_start1 = strtotime($A['time_start1']);
                    $starthour1 = strftime("%H", $time_start1);
                    $startminute1 = strftime("%M", $time_start1);
                } else {
                    $starthour1 = '';
                    $startminute1 = '';
                }
                
                //date_end1 shouldn't exist if date_start 1 doesn't
                if (!empty($A['date_end1']) && $A['date_end1'] != '0000-00-00') {
                    $date_end1 = strtotime($A['date_end1']);
                    $endday1 = strftime("%d", $date_end1);
                    $endmonth1 = strftime("%m", $date_end1);
                    $endyear1 = strftime("%Y", $date_end1);
                    
                    //no time if no date
                    if (!empty($A['time_end1'])) {
                        $time_end1 = strtotime($A['time_end1']);
                        $endhour1 = strftime("%H", $time_end1);
                        $endminute1 = strftime("%M", $time_end1);
                    } else {
                        $endhour1 = '';
                        $endminute1 = '';
                    }
                } else {
                    $endday1 = '';
                    $endmonth1 = '';
                    $endyear1 = '';
                    $endhour1 = '';
                    $endminute1 = '';
                }
                
                //split info
                //date_start2 shouldn't exist if not split
                if ($A['split'] != '1') {
                    //disable date and time 2
                    $t->set_var('split_checked', '');
                    $t->set_var('datetime2_show', ' style="display:none"');
                    //and enable the allday checkbox
                    $t->set_var('allday_show', '');
                } else {
                    $t->set_var('split_checked', ' checked="checked"');
                    //disable the allday checkbox
                    $t->set_var('allday_show', ' style="display:none"');
                    
                    //date_start2 shouldn't exist if date_start1 doesn't or if event is not split
                    if (!empty($A['date_start2']) && $A['date_start2'] != '0000-00-00') {
                        $date_start2 = strtotime($A['date_start2']);
                        $startday2 = strftime("%d", $date_start2);
                        $startmonth2 = strftime("%m", $date_start2);
                        $startyear2 = strftime("%Y", $date_start2);
                        
                        //no time if no date
                        if (!empty($A['time_start2'])) {
                            $time_start2 = strtotime($A['time_start2']);
                            $starthour2 = strftime("%H", $time_start2);
                            $startminute2 = strftime("%M", $time_start2);
                        } else {
                            $starthour2 = '';
                            $startminute2 = '';
                        }
                        
                        //date_end2 shouldn't exist if date_start2 doesn't
                        if (!empty($A['date_end2']) && $A['date_end2'] != '0000-00-00') {
                            $date_end2 = strtotime($A['date_end2']);
                            $endday2 = strftime("%d", $date_end2);
                            $endmonth2 = strftime("%m", $date_end2);
                            $endyear2 = strftime("%Y", $date_end2);
                            
                            //no time if no date
                            if (!empty($A['time_end2'])) {
                                $time_end2 = strtotime($A['time_end2']);
                                $endhour2 = strftime("%H", $time_end2);
                                $endminute2 = strftime("%M", $time_end2);
                            } else {
                                $endhour2 = '';
                                $endminute2 = '';
                            }
                        } else {
                            $endday2 = '';
                            $endmonth2 = '';
                            $endyear2 = '';
                            $endhour2 = '';
                            $endminute2 = '';
                        }
                    } else {
                        $startday2 = '';
                        $startmonth2 = '';
                        $startyear2 = '';
                        $endday2 = '';
                        $endmonth2 = '';
                        $endyear2 = '';
                        $starthour2 = '';
                        $startminute2 = '';
                        $endhour2 = '';
                        $endminute2 = '';
                    }
                }
            } else {
                $startday1 = '';
                $startmonth1 = '';
                $startyear1 = '';
                $endday1 = '';
                $endmonth1 = '';
                $endyear1 = '';
                $starthour1 = '';
                $startminute1 = '';
                $endhour1 = '';
                $endminute1 = '';
            }
            
            //recurring info
            if ($A['recurring'] != '1') {
                $t->set_var('recurring_show', ' style="display:none;"');
                for ($i = 1; $i <= 6; $i++) {
                    $t->set_var('format' . $i . 'show', ' style="display:none;"');
                }
            } elseif ($A['recurring'] == '1') {
                //rec_data
                $option = empty($A['rec_option']) ? '0' : $A['rec_option'];
                $rec_data = explode(";", $A['rec_data']);
                
                $t->set_var(array(
                    'recurring_show' => '',
                    'recurring_checked' => ' checked="checked"'
                ));
                
                for ($i = 1; $i <= 6 ; $i++) {
                    if ($i != $option) {
                        $t->set_var('format' . $i . 'show', ' style="display:none;"');
                    } else {
                        $t->set_var('format' . $i . 'show', '');
                        switch ($i) {
                        case 1:
                            if (!empty($rec_data[0])) {
                                $dailystop = strtotime($rec_data[0]);
                                $dailystopY = strftime("%Y", $dailystop);
                                $dailystopM = strftime("%m", $dailystop);
                                $dailystopD = strftime("%d", $dailystop);
                            } else {
                                $dailystopY = '';
                                $dailystopM = '';
                                $dailystopD = '';
                            }
                            if ($rec_data[1] == '1') {
                                $t->set_var('skipWD_checked', ' checked="checked"');
                            }
                            break;
                        case 2:
                            if (!empty($rec_data[0])) {
                                $monthlystop = strtotime($rec_data[0]);
                                $monthlystopY = strftime("%Y", $monthlystop);
                                $monthlystopM = strftime("%m", $monthlystop);
                            } else {
                                $monthlystopY = '';
                                $monthlystopM = '';
                            }
                            if (!empty($rec_data[1])) {
                                $t->set_var('skipnextM' . $rec_data[1]  . '_checked', ' checked="checked"');
                            }
                            break;
                        case 3:
                            if (!empty($rec_data[0])) {
                                $yearlystop = strtotime($rec_data[0]);
                                $yearlystopY = strftime("%Y", $yearlystop);
                            } else {
                                $yearlystopY = '';
                            }
                            if (!empty($rec_data[1])) {
                                $t->set_var('skipnextY' . $rec_data[1]  . '_checked', ' checked="checked"');
                            }
                            break;
                        case 4:
                            $t->set_var('listdays_val', COM_stripslashes($rec_data[0]));
                            if (!empty($rec_data[1])) {
                                $listdaystop = strtotime($rec_data[1]);
                                $listdaystopY = strftime("%Y", $listdaystop);
                                $listdaystopM = strftime("%m", $listdaystop);
                                $listdaystopD = strftime("%d", $listdaystop);
                            } else {
                                $listdaystopY = '';
                                $listdaystopM = '';
                                $listdaystopD = '';
                            }
                            break;
                        case 5:
                            $recinterval = COM_stripslashes($rec_data[0]);
                            $recweekday = COM_stripslashes($rec_data[1]);
                            if (!empty($rec_data[2])) {
                                $intervalstop = strtotime($rec_data[2]);
                                $intervalstopY = strftime("%Y", $intervalstop);
                                $intervalstopM = strftime("%m", $intervalstop);
                            } else {
                                $intervalstopY = '';
                                $intervalstopM = '';
                            }
                            break;
                        case 6:
                            $t->set_var('custom_val', COM_stripslashes($rec_data[0]));
                            break;
                        }
                    }
                }
            }
            
            //allday info
            if ($A['allday'] != '1' && $A['split'] == '1') {
                $t->set_var('allday_show', ' style="display:none"');
                $t->set_var('split_show', '');
            } elseif ($A['allday'] != '1') {
                $t->set_var('allday_show', '');
                $t->set_var('allday_checked', '');
            } elseif ($A['allday'] == '1') {
                $t->set_var('allday_show', '');
                $t->set_var('allday_checked', ' checked="checked"');
                $t->set_var('split_show', ' style="display:none"');
            }
            
            //location info
            $url = (empty($A['url'])) ? '' : COM_stripslashes($A['url']);
            //$location = (empty($A['location'])) ? '' : COM_stripslashes($A['location']);
            $street = (empty($A['street'])) ? '' : COM_stripslashes($A['street']);
            $city = (empty($A['city'])) ? '' : COM_stripslashes($A['city']);
            $province = (empty($A['province'])) ? '' : COM_stripslashes($A['province']);
            $country = (empty($A['country'])) ? '' : COM_stripslashes($A['country']);
            $postal = (empty($A['postal'])) ? '' : COM_stripslashes($A['postal']);
            $t->set_var(array(
                'url' => $url,
                //'location' => $location,
                'street' => $street,
                'city' => $city,
                'province' => $province,
                'country' => $country,
                'postal' => $postal
            ));
            
            //contact info
            $contact = (empty($A['contact'])) ? '' : COM_stripslashes($A['contact']);
            $email = (empty($A['email'])) ? '' : COM_stripslashes($A['email']);
            $phone = (empty($A['phone'])) ? '' : COM_stripslashes($A['phone']);
            $t->set_var(array(
                'contact' => $contact,
                'email' => $email,
                'phone' => $phone
            ));
            
            //reminder info
            if ($A['enable_reminders'] == '1') {
                $t->set_var('rem_status_checked', 'checked="checked"');
                $t->set_var('rem_note', $LANG_EVLIST04[77]);
            }
            
            //access info
            if (SEC_hasRights('evlist.edit')) {
                $ownerusername = DB_getItem($_TABLES['users'], 'username', "uid='{$A['owner_id']}'");
                $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
                
                $t->set_var(array(
                    'owner_uid' => $A['owner_id'],
                    'owner_username' => COM_stripslashes($ownerusername),
                    'group_dropdown' => SEC_getGroupDropdown ($A['group_id'], $access),
                    'permissions_editor' => SEC_getPermissionsHTML($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon'])
                ));
            }
            
            //delete button
            $t->set_var('delete', $LANG_EVLIST04[9]);
            $t->parse('delete_option', 'del_option');
        }
    } else {
        //adding new event
        //display empty fields
        $t->set_var(array(
            #'eid' => '',
            #'title' => '',
            #'summary' => '',
            #'description' => '',
            #'contact' => '',
            #'email' => '',
            #'phone' => '',
            #'url' => '',
            #'location' => '',
            #'street' => '',
            #'city' => '',
            #'province' => '',
            #'country' => '',
            #'postal' => '',
            #'allday_checked' => '',
            'status_checked' => ' checked="checked"',
            'datetime2_show' => ' style="display:none;"',
            'recurring_show' => ' style="display:none;"'
        ));
        $startday2 = '';
        $startmonth2 = '';
        $startyear2 = '';
        $endday2 = '';
        $endmonth2 = '';
        $endyear2 = '';
        $starthour2 = '';
        $startminute2 = '';
        $endhour2 = '';
        $endminute2 = '';
        $startday1 = '';
        $startmonth1 = '';
        $startyear1 = '';
        $endday1 = '';
        $endmonth1 = '';
        $endyear1 = '';
        $starthour1 = '';
        $startminute1 = '';
        $endhour1 = '';
        $endminute1 = '';
        $postmode = '1'; //default postmode = plaintext
        $option = '0'; //rec_option
        $status_checked = ' checked="checked"';
        $dailystopY = '';
        $dailystopM = '';
        $dailystopD = '';
        $monthlystopY = '';
        $monthlystopM = '';
        $yearlystopY = '';
        $listdaystopY = '';
        $listdaystopM = '';
        $listdaystopD = '';
        $intervalstopY = '';
        $intervalstopM = '';
        
        //recurring field divs
        for ($i = 1; $i <= 6; $i++) {
            $t->set_var('format' . $i . 'show', ' style="display:none;"');
        }
        
        //access info
        if (SEC_hasRights('evlist.edit')) {
            //use default values from $CONF_EVLIST['default_permissions'] or not
            $A['owner_id'] = $_USER['uid'];
            if (isset ($_GROUPS['evList Admin'])) {
                $A['group_id'] = $_GROUPS['evList Admin'];
            } else {
                $A['group_id'] = SEC_getFeatureGroup ('evlist.edit');
            }
            SEC_setDefaultPermissions ($A, $_CONF['default_permissions_block']);
            $access = SEC_hasAccess($A['owner_id'],$A['group_id'],$A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
            $t->set_var(array(
                'owner_username' => $_USER['username'],
                'owner_uid' => $_USER['uid'],
                'group_dropdown' => SEC_getGroupDropdown ($A['group_id'], $access),
                'permissions_editor' => SEC_getPermissionsHTML($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon'])
            ));
        }
    }
    
    $t->set_var(array(
        'action' => $_CONF['site_url'] . '/evlist/event.php',
        'start_day_options1' => COM_getDayFormOptions($startday1),
        'start_month_options1' => COM_getMonthFormOptions($startmonth1),
        'start_year_options1' => COM_getYearFormOptions($startyear1),
        'end_day_options1' => COM_getDayFormOptions($endday1),
        'end_month_options1' => COM_getMonthFormOptions($endmonth1),
        'end_year_options1' => COM_getYearFormOptions($endyear1),
        'start_hour_options1' => COM_getHourFormOptions($starthour1, $hour_mode),
        'start_minute_options1' => COM_getMinuteFormOptions($startminute1, '15'),
        'end_hour_options1' => COM_getHourFormOptions($endhour1, $hour_mode),
        'end_minute_options1' => COM_getMinuteFormOptions($endminute1, '15'),
        'start_day_options2' => COM_getDayFormOptions($startday2),
        'start_month_options2' => COM_getMonthFormOptions($startmonth2),
        'start_year_options2' => COM_getYearFormOptions($startyear2),
        'end_day_options2' => COM_getDayFormOptions($endday2),
        'end_month_options2' => COM_getMonthFormOptions($endmonth2),
        'end_year_options2' => COM_getYearFormOptions($endyear2),
        'start_hour_options2' => COM_getHourFormOptions($starthour2, $hour_mode),
        'start_minute_options2' => COM_getMinuteFormOptions($startminute2, '15'),
        'end_hour_options2' => COM_getHourFormOptions($endhour2, $hour_mode),
        'end_minute_options2' => COM_getMinuteFormOptions($endminute2, '15'),
        'format_option' => $LANG_EVLIST04[64],
        'recurring_format_options' => evlist_getRecurringFormatOptions($option),
        //'recurring_month_options' => COM_getDayFormOptions($recmonth),
        'recurring_interval_options' => evlist_getRecurringIntervalOptions($recinterval),
        'recurring_weekday_options' => evlist_getRecurringWeekdayOptions($recweekday),
        'dailystopY_options' => COM_getYearFormOptions($dailystopY),
        'dailystopM_options' => COM_getMonthFormOptions($dailystopM),
        'dailystopD_options' => COM_getDayFormOptions($dailystopD),
        'monthlystopY_options' => COM_getYearFormOptions($monthlystopY),
        'monthlystopM_options' => COM_getMonthFormOptions($monthlystopM),
        'yearlystopY_options' => COM_getYearFormOptions($yearlystopY),
        'listdaystopY_options' => COM_getYearFormOptions($listdaystopY),
        'listdaystopM_options' => COM_getMonthFormOptions($listdaystopM),
        'listdaystopD_options' => COM_getDayFormOptions($listdaystopD),
        'intervalstopY_options' => COM_getYearFormOptions($intervalstopY),
        'intervalstopM_options' => COM_getMonthFormOptions($intervalstopM),
        'skipweekends_label' => $LANG_EVLIST04[73],
        'nextbusday_label' => $LANG_EVLIST04[74],
        'skipnext_note' => $LANG_EVLIST04[75],
        'event_legend' => $LANG_EVLIST04[2],
        'datetime_legend' => $LANG_EVLIST04[3],
        'location_legend' => $LANG_EVLIST04[4],
        'contact_legend' => $LANG_EVLIST04[5],
        'access_legend' => $LANG_EVLIST04[6],
        'recurring_legend' => $LANG_EVLIST04[49],
        'save' => $LANG_EVLIST04[7],
        'reset' => $LANG_EVLIST04[8],
        'cancel' => $LANG_EVLIST04[10],
        'title_label' => $LANG_EVLIST04[11],
        'summary_label' => $LANG_EVLIST04[12],
        'description_label' => $LANG_EVLIST04[13],
        'title_note' => $LANG_EVLIST04[28],
        'start_label' => $LANG_EVLIST04[14],
        'end_label' => $LANG_EVLIST04[15],
        'day_label' => $LANG_EVLIST04[16],
        'month_label' => $LANG_EVLIST04[17],
        'year_label' => $LANG_EVLIST04[18],
        'hour_label' => $LANG_EVLIST04[19],
        'minute_label' => $LANG_EVLIST04[20],
        'startdate_label' => $LANG_EVLIST04[33],
        'starttime_label' => $LANG_EVLIST04[34],
        'enddate_label' => $LANG_EVLIST04[35],
        'endtime_label' => $LANG_EVLIST04[36],
        'recurring_label' => $LANG_EVLIST04[29],
        'format_label' => $LANG_EVLIST04[30],
        'split_label' => $LANG_EVLIST04[31],
        'allday_label' => $LANG_EVLIST04[32],
        'location_label' => $LANG_EVLIST04[21],
        'street_label' => $LANG_EVLIST04[22],
        'city_label' => $LANG_EVLIST04[23],
        'province_label' => $LANG_EVLIST04[24],
        'country_label' => $LANG_EVLIST04[40],
        'postal_label' => $LANG_EVLIST04[25],
        'url_label' => $LANG_EVLIST04[26],
        'email_label' => $LANG_EVLIST04[37],
        'phone_label' => $LANG_EVLIST04[38],
        'contact_label' => $LANG_EVLIST04[39],
        'dailystop_label' => sprintf($LANG_EVLIST04[66],$LANG_EVLIST04[52],''),
        'fnote1' => $LANG_EVLIST04[53],
        //'monthly_label' => sprintf($LANG_EVLIST04[50],$LANG_EVLIST04[54],$LANG_EVLIST04[65]),
        'monthlystop_label' => sprintf($LANG_EVLIST04[66],$LANG_EVLIST04[55],$LANG_EVLIST04[51]),
        'fnote2' => $LANG_EVLIST04[56],
        'yearlystop_label' => sprintf($LANG_EVLIST04[66],$LANG_EVLIST04[57],$LANG_EVLIST04[51]),
        'fnote3' => $LANG_EVLIST04[58],
        'listdays_label' => sprintf($LANG_EVLIST04[50],$LANG_EVLIST04[59],''),
        'fnote4' => $LANG_EVLIST04[60],
        'listdaystop_label' => sprintf($LANG_EVLIST04[66],$LANG_EVLIST04[54],$LANG_EVLIST04[51]),
        'interval_label' => sprintf($LANG_EVLIST04[50],$LANG_EVLIST04[61],''),
        'intervalstop_label' => sprintf($LANG_EVLIST04[66],$LANG_EVLIST04[55],$LANG_EVLIST04[51]),
        'custom_label' => sprintf($LANG_EVLIST04[50],$LANG_EVLIST04[62],''),
        'fnote6' => $LANG_EVLIST04[63],
        'datestart_note' => $LANG_EVLIST04[67]
    ));
    
    //category info
    if ($S['enable_categories'] == '1') {
        $cresult = DB_query("SELECT DISTINCT id, name, eid FROM {$_TABLES['evlist_categories']} tc
            LEFT JOIN {$_TABLES['evlist_lookup']} tl ON id = cid AND eid = '$eid' WHERE tc.status='1' ORDER BY name");
        
        $t->set_var(array(
            'category_legend' => $LANG_EVLIST04[68],
            'category_label' => $LANG_EVLIST04[71],
            'category_note' => $LANG_EVLIST04[72]
        ));
        
        $numcats = DB_numRows($cresult);
        
        if ($numcats >= 1) {
            while ($C = DB_fetchArray($cresult)) {
                $t->set_var(array(
                    'category_name' => COM_stripslashes($C['name']),
                    'category_id' => COM_stripslashes($C['id'])
                ));
                
                //if (!empty($eid) && $C['eid'] == $eid) {
                if (!is_null($C['eid'])) {
                    $t->set_var('cat_checked', ' checked="checked"');
                }
                $t->parse ('cat_item','category', true);
                $t->clear_var('cat_checked');
            }
        }
        
        if ($_USER['uid'] > 1) {
            $t->set_file('add_cat','add_cat.thtml');
            $t->set_var(array(
                'addcat_note' => $LANG_EVLIST04[70],
                'addcat_label' => $LANG_EVLIST04[69]
            ));
            $t->parse ('add_cat_input', 'add_cat');
        }
        
        if (($numcats < 1 && $_USER['uid'] > 1) || $numcats >= 1) {
            //if no categories exist and anon users can't add categories then they don't need to see the fieldset.
            $t->parse ('categories','category_set');
        }
    }
    
    if (SEC_hasRights('evlist.edit') || ($S['allow_html'] == '1' && $_USER['uid'] > 1)) {
        $t->set_var(array(
            'postmode_options' => evlist_getPostmodeOptions($postmode),
            'postmode_label' => $LANG_EVLIST04[46],
            'allowed_html' => COM_allowedHTML('evlist.edit'),
            'location_note' => $LANG_EVLIST04[47]
        ));
        if ($postmode == '1') {
            $t->set_var('postmode_show', ' style="display:none"');
        }
        $t->parse('event_postmode', 'edit_postmode');
    }
    
    if (SEC_hasRights('evlist.edit')) {
        $t->set_var(array(
            'owner_label' => $LANG_EVLIST04[43],
            'group_label' => $LANG_EVLIST04[44],
            'permissions_label' => $LANG_EVLIST04[41],
            'perms_note' => $LANG_EVLIST04[42],
        ));
        $t->parse('event_access', 'perms');
        
        $t->set_var(array(
            'status_label' => $LANG_EVLIST04[48],
            'status_checked' => $status_checked
        ));
        $t->parse('event_status_box', 'status');
        
        if ($S['enable_reminders'] == '1') {
            $t->set_var('rem_status_label', $LANG_EVLIST04[76]);
            $t->parse('rem_status_box', 'rem_status');
        }
    }
    
    $t->parse('output', 'editor');
    $retval .= $t->finish($t->get_var('output'));
    
    $retval .= COM_endBlock();
    return $retval;
}

function evlist_save_event($A, $eid = '') {
    global $_CONF, $_TABLES, $_USER, $CONF_EVLIST;
    
    //check if speed limit breeched
    //applies to new events not posted by evlist admin
    COM_clearSpeedlimit ($CONF_EVLIST['post_speedlimit'], 'event');
    $last = COM_checkSpeedlimit ('event');
    if ($last > 0 && empty($eid) && !SEC_hasRights('evlist.edit')) {
        $return_page = $_CONF['site_url'] . '/evlist/event.php?op=new&msg=15';
        return COM_refresh($return_page);
    }
    
    $retval = '';
    
    $result = DB_query("SELECT * FROM {$_TABLES['evlist_settings']}");
    $S = DB_fetchArray($result);
    
    $A['title'] = COM_stripslashes($A['title']);
    $A['summary'] = COM_stripslashes($A['summary']);
    $A['description'] = COM_stripslashes($A['description']);

    // pseudo-formatted event item for the spam check
    $spamcheck = '<h1>' . $A['title'] . '</h1><p>' . $A['summary'] . '</p><p>' . $A['full_description'] . '</p>';
    $result = PLG_checkforSpam ($spamcheck, $_CONF['spamx']);
    if ($result > 0) {
        COM_updateSpeedlimit ('event');
        COM_displayMessageAndAbort ($result, 'spamx', 403, 'Forbidden');
    }

    $A['title'] = addslashes (strip_tags (COM_checkWords ($A['title'])));
    
    if ((SEC_hasRights('evlist.edit') || ($S['allow_html'] == '1' && $_USER['uid'] > 1)) && $A['postmode'] == '2') {//html
        $A['summary'] = addslashes (COM_checkHTML (COM_checkWords ($A['summary'])));
        $A['description'] = addslashes (COM_checkHTML (COM_checkWords ($A['description'])));
        $A['location'] = addslashes (COM_checkHTML (COM_checkWords ($A['location'])));
    } else {//plaintext
        $A['postmode'] = '1';
        $A['summary'] = addslashes (COM_makeClickableLinks (htmlspecialchars (COM_checkWords ($A['summary']))));
        $A['description'] = addslashes (COM_makeClickableLinks (htmlspecialchars (COM_checkWords ($A['description']))));
        $A['location'] = addslashes (COM_makeClickableLinks (htmlspecialchars (COM_checkWords ($A['location']))));
    }
    
    if (!empty($A['startmonth1'])) {
        //start month and year are required fields so should never be empty
        $A['startday1'] = COM_applyFilter($A['startday1'],true);
        
        if (empty($A['startday1'])) {
            $A['startday1'] = '-01';
        }
        
        $A['date_start1'] = COM_applyFilter($A['startyear1'],true) . '-' . COM_applyFilter($A['startmonth1'],true) . '-' . $A['startday1'];
        
        $A['starthour1'] = COM_applyFilter($A['starthour1'],true);
        $A['startminute1'] = COM_applyFilter($A['startminute1'],true);
        
        if(!empty($A['starthour1'])) {
            if (empty($A['startminute1'])) {
                $A['startminute1'] = '00';
            }
            $A['time_start1'] = $A['starthour1'] . ':' . $A['startminute1'] . ':00';
        } else {
            //the following value is zero so that null values aren't returned in the event list query.
            $A['time_start1'] = '0';
        }
        
        $A['endday1'] = COM_applyFilter($A['endday1'],true);
        $A['endmonth1'] = COM_applyFilter($A['endmonth1'],true);
        $A['endyear1'] = COM_applyFilter($A['endyear1'],true);
        
        if (!empty($A['endyear1'])) {
            if (!empty($A['endmonth1'])) {
                if (empty($A['endday1'])) {
                    $A['endday1'] = '01';
                }
            } else {
                $A['endmonth1'] = '01';
                $A['endday1'] = '01';
            }
            $A['date_end1'] = $A['endyear1'] . '-' . $A['endmonth1'] . '-' . $A['endday1'];
            
            $A['endhour1'] = COM_applyFilter($A['endhour1'],true);
            $A['endminute1'] = COM_applyFilter($A['endminute1'],true);
            
            if (!empty($A['endhour1'])) {
                if (empty($A['endminute1'])) {
                    $A['endminute1'] = '00';
                }
                $A['time_end1'] = $A['endhour1'] . ':' . $A['endminute1'] . ':00';
            } else {
                $A['time_end1'] = '';
            }
        } else {
            $A['date_end1'] = '';
            $A['time_end1'] = '';
        }
        
        if ($A['split'] == '1') {
            $A['allday'] = '0';
            
            $A['startday2'] = COM_applyFilter($A['startday2'],true);
            $A['startmonth2'] = COM_applyFilter($A['startmonth2'],true);
            $A['startyear2'] = COM_applyFilter($A['startyear2'],true);
            
            if(!empty($A['startyear2'])) {
                if (!empty($A['startmonth2'])) {
                    if (empty($A['startday2'])) {
                        $A['startday2'] = '01';
                    }
                } else {
                    $A['startmonth2'] = '01';
                    $A['startday2'] = '01';
                }
                $A['date_start2'] = $A['startyear2'] . '-' . $A['startmonth2'] . '-' . $A['startday2'];
                
                $A['starthour2'] = COM_applyFilter($A['starthour2'],true);
                $A['startminute2'] = COM_applyFilter($A['startminute2'],true);
                
                if(!empty($A['starthour2'])) {
                    if (empty($A['startminute2'])) {
                        $A['startminute2'] = '00';
                    }
                    $A['time_start2'] = $A['starthour2'] . ':' . $A['startminute2'] . ':00';
                } else {
                    $A['time_start2'] = '';
                }
                
                $A['endday2'] = COM_applyFilter($A['endday2'],true);
                $A['endmonth2'] = COM_applyFilter($A['endmonth2'],true);
                $A['endyear2'] = COM_applyFilter($A['endyear2'],true);
                
                if (!empty($A['endyear2'])) {
                    if (!empty($A['endmonth2'])) {
                        if (empty($A['endday2'])) {
                            $A['endday2'] = '01';
                        }
                    } else {
                        $A['endmonth2'] = '01';
                        $A['endday2'] = '01';
                    }
                    $A['date_end2'] = $A['endyear2'] . '-' . $A['endmonth2'] . '-' . $A['endday2'];
                    
                    $A['endhour2'] = COM_applyFilter($A['endhour2'],true);
                    $A['endminute2'] = COM_applyFilter($A['endminute2'],true);
                    
                    if (!empty($A['endhour2'])) {
                        if (empty($A['endminute2'])) {
                            $A['endminute2'] = '00';
                        }
                        $A['time_end2'] = $A['endhour2'] . ':' . $A['endminute2'] . ':00';
                    } else {
                        $A['time_end2'] = '';
                    }
                } else {
                    $A['date_end2'] = '';
                    $A['time_end2'] = '';
                }
            } else {
                $A['split'] = '0';
                $A['date_start2'] = '';
                $A['date_end2'] = '';
                $A['time_start2'] = '';
                $A['time_end2'] = '';
            }
        } else {
            if ($A['allday'] != '1') {
                $A['allday'] = '0';
            }
            $A['split'] = '0';
            $A['date_start2'] = '';
            $A['date_end2'] = '';
            $A['time_start2'] = '';
            $A['time_end2'] = '';
        }
    } else {//wont ever happen..
        $A['allday'] = '0';
        $A['split'] = '0';
        $A['date_start1'] = '';
        $A['date_end1'] = '';
        $A['time_start1'] = '';
        $A['time_end1'] = '';
        $A['date_start2'] = '';
        $A['date_end2'] = '';
        $A['time_start2'] = '';
        $A['time_end2'] = '';
    }
    
    if ($A['recurring'] != '1') {
        $A['recurring'] = '0';
        $A['rec_option'] = '';
        $A['rec_data'] = '';
    } else {
        $A['rec_option'] = COM_applyFilter($A['format'],true);
        switch ($A['rec_option']) {
        case 1:
            $A['dailystopY'] = COM_applyFilter($A['dailystopY'],true);
            $A['dailystopM'] = COM_applyFilter($A['dailystopM'],true);
            $A['dailystopD'] = COM_applyFilter($A['dailystopD'],true);
            $A['skipweekendsD'] = COM_applyFilter($A['skipweekendsD'],true);
            
            //consider using safestrtotime() so limits aren't 1970 - 2038.
            // or check for php version and go from there.  will get to this later.
            if (!empty($A['dailystopY'])) {
                if (!empty($A['dailystopM'])) {
                    if (empty($A['dailystopD'])) {
                        //find last day of month
                        $A['dailystopD'] = evlist_getLastDay($A['dailystopY'],$A['dailystopM']);
                    }
                } else {
                    $A['dailystopM'] = '12';
                    $A['dailystopD'] = '31';
                }
                $A['rec_data'] = $A['dailystopY'] . '-' . $A['dailystopM'] . '-' . $A['dailystopD'];
                if (strtotime($A['rec_data']) > strtotime("2037-01-01")) {
                    $A['rec_data'] = "2037-01-01";
                }
            }
            
            if (!empty($A['skipweekendsD'])) {
                $A['rec_data'] .= ';' . $A['skipweekendsD'];
            }
            break;
        case 2:
            $A['monthlystopY'] = COM_applyFilter($A['monthlystopY'],true);
            $A['monthlystopM'] = COM_applyFilter($A['monthlystopM'],true);
            $A['skipnextM'] = COM_applyFilter($A['skipnextM'],true);
            
            if (!empty($A['monthlystopY'])) {
                if (empty($A['monthlystopM'])) {
                    $A['monthlystopM'] = '12';
                }
                //find last day of month
                $lastday = evlist_getLastDay($A['monthlystopY'],$A['monthlystopM']);
                $A['rec_data'] = $A['monthlystopY'] . '-' . $A['monthlystopM'] . $lastday;
                if (strtotime($A['rec_data']) > strtotime("2037-01-01")) {
                    $A['rec_data'] = "2037-01-01";
                }
            }
            
            if (!empty($A['skipnextM'])) {
                $A['rec_data'] .= ';' . $A['skipnextM'];
            }
            break;
        case 3:
            $A['yearlystopY'] = COM_applyFilter($A['yearlystopY'],true);
            $A['skipnextY'] = COM_applyFilter($A['skipnextY'],true);
            
            if (!empty($A['yearlystopY'])) {
                $A['rec_data'] = $A['yearlystop'] . '-12-31';
                if (strtotime($A['rec_data']) > strtotime("2037-01-01")) {
                    $A['rec_data'] = "2037-01-01";
                }
            }
            
            if (!empty($A['skipnextY'])) {
                $A['rec_data'] .= ';' . $A['skipnextY'];
            }
            break;
        case 4:
            $A['listdaystopY'] = COM_applyFilter($A['listdaystopY'],true);
            $A['listdaystopM'] = COM_applyFilter($A['listdaystopM'],true);
            $A['listdaystopD'] = COM_applyFilter($A['listdaystopD'],true);
            
            if (!empty($A['listdaystopY'])) {
                if (!empty($A['listdaystopM'])) {
                    if (empty($A['listdaystopD'])) {
                        //find last day of month
                        $A['listdaystopD'] = evlist_getLastDay($A['listdaystopY'],$A['listdaystopM']);
                    }
                } else {
                    $A['listdaystopM'] = '12';
                    $A['listdaystopD'] = '31';
                }
                $listdaystop = $A['listdaystopY'] . '-' . $A['listdaystopM'] . '-' . $A['listdaystopD'];
                if (strtotime($listdaystop) > strtotime("2037-00-00")) {
                    $listdaystop = "2037-00-00";
                }
            }
            
            $listdaysA = explode(",", $A['listdays']);
            $listdaysA = array_filter($listdaysA);
            sort($listdaysA);
            $countdays = count($listdaysA);
            if ($countdays > 7) {
                array_slice($daynumA, 0, 7);
            }
            reset($listdaysA);
            $listdays = '';
            for ($i = 0; $i < $countdays; $i++) {
                $dval = COM_applyFilter(trim($listdaysA[$i]),true);
                
                if (!empty($dval) && ($dval >= 1 && $dval <= 7)) {
                    if ($i == $countdays - 1) {
                        $listdays .= $dval;
                    } else {
                        $listdays .= $dval . ',';
                    }
                }
            }
            
            $A['rec_data'] = $listdays . ';' . $listdaystop;
            break;
        case 5:
            $A['intervalstopY'] = COM_applyFilter($A['intervalstopY'],true);
            $A['intervalstopM'] = COM_applyFilter($A['intervalstopM'],true);
            //$A['intervalstopD'] = COM_applyFilter($A['intervalstopD'],true);
            if (!empty($A['intervalstopY'])) {
                if (empty($A['intervalstopM'])) {
                    $A['intervalstopM'] = '12';
                    $A['intervalstopD'] = '31';
                }
                //find last day of month
                $lastday = evlist_getLastDay($A['intervalstopY'],$A['intervalstopM']);
                $intervalstop = $A['intervalstopY'] . '-' . $A['intervalstopM'] . '-' . $lastday;
                
                if (strtotime($intervalstop) > strtotime("2037-00-00")) {
                    $intervalstop = "2037-00-00";
                }
            }
            
            $A['rec_data'] = COM_applyFilter($A['interval'],true) . ';' . COM_applyFilter($A['weekday'],true) . ';' . $intervalstop . '-00';
            break;
        case 6:
            $listdatesA = explode(",", $A['custom']);
            array_filter($listdatesA);
            $countdates = count($listdatesA);
            $listdates = '';
            for ($i = 0; $i < $countdates; $i++) {
                $dval = COM_applyFilter(trim($listdatesA[$i]));
                if (!empty($dval)) {
                    if ($i == $countdates - 1) {
                        $listdates .= $dval;
                    } else {
                        $listdates .= $dval . ',';
                    }
                }
            }
            
            $A['rec_data'] = $listdates;
            break;
        }
    }
    
    $A['url'] = COM_sanitizeUrl($A['url']);
    $A['street'] = addslashes (strip_tags (COM_checkWords($A['street'])));
    $A['city'] = addslashes (strip_tags (COM_checkWords($A['city'])));
    $A['province'] = addslashes (strip_tags (COM_checkWords($A['province'])));
    $A['country'] = addslashes (strip_tags (COM_checkWords($A['country'])));
    $A['postal'] = addslashes (strip_tags (COM_checkWords($A['postal'])));
    
    $A['contact'] = addslashes (strip_tags (COM_checkWords($A['contact'])));
    $A['email'] = strip_tags (COM_checkWords ($A['email']));
    if (!COM_isEmail($A['email'])) {
        $A['email'] = '';
    } else {
        $A['email'] = addslashes($A['email']);
    }
    $A['phone'] = addslashes (strip_tags (COM_checkWords($A['phone'])));
    
    if (!SEC_hasRights('evlist.edit')) {
        //default perms
        SEC_setDefaultPermissions ($A, $CONF_EVLIST['default_permissions']);
    } else {
        // Convert array values to numeric permission values
        list($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon'])
            = SEC_getPermissionValues($A['perm_owner'],$A['perm_group'],$A['perm_members'],$A['perm_anon']);
    }
    
    if (!empty($A['eid'])) {
        $A['eid'] = addslashes(COM_sanitizeID($A['eid'], false));
    } else {
        $A['eid'] = '';
    }
    
    if (SEC_hasRights('evlist.edit')) {//admin user so they get a choice
        if ($A['status'] != '1') {
            $A['status'] = '0';
        }
        if ($A['rem_status'] != '1') {
            $A['rem_status'] = '0';
        }
    } elseif (!empty($eid)) {
        //reg user doessn't get a choice re event status or email reminders
        $A['status'] = DB_getItem($_TABLES['evlist_events'], 'status', "eid='$eid'");
        if ($A['status'] != 1) {
            $A['status'] = '0';
        }
        $A['rem_status'] = '0';
    } else {//reg/anon user and new event -- no choice
        $A['status'] = '0';
        $A['rem_status'] = '0';
    }
    
    if (!empty($eid)) {
        $A['owner_id'] = COM_applyFilter($A['owner_id'], true);
        $A['group_id'] = COM_applyFilter($A['group_id'], true);
    } else {
        if (isset ($_USER['uid']) && ($_USER['uid'] > 1)) {
            $A['owner_id'] = $_USER['uid'];
            if (isset ($_GROUPS['evList Admin'])) {
                $A['group_id'] = $_GROUPS['evList Admin'];
            } else {
                $A['group_id'] = SEC_getFeatureGroup ('evlist.edit');
            }
        } else {
            $A['owner_id'] = '2';//anonymous additions are given to admin uid
            if (isset ($_GROUPS['evList Admin'])) {
                $A['group_id'] = $_GROUPS['evList Admin'];
            } else {
                $A['group_id'] = '1';//root group
            }
        }
    }
    
    if (SEC_hasRights('evlist.edit')) { // post this event directly
        
        if (!empty($A['eid']) && empty($A['submission'])) {
            
            //update event
            DB_query("UPDATE {$_TABLES['evlist_events']} SET
                id = '{$A['eid']}',
                title = '{$A['title']}', summary = '{$A['summary']}',
                full_description = '{$A['description']}', date_start1 = '{$A['date_start1']}',
                date_end1 = '{$A['date_end1']}', time_start1 = '{$A['time_start1']}',
                time_end1 = '{$A['time_end1']}', date_start2 = '{$A['date_start2']}',
                date_end2 = '{$A['date_end2']}', time_start2 = '{$A['time_start2']}',
                time_end2 = '{$A['time_end2']}', url = '{$A['url']}', location = '{$A['location']}',
                street = '{$A['street']}', city = '{$A['city']}', province = '{$A['province']}',
                country = '{$A['country']}', postal = '{$A['postal']}', recurring = '{$A['recurring']}',
                rec_option = '{$A['rec_option']}', rec_data = '{$A['rec_data']}', allday = '{$A['allday']}',
                split = '{$A['split']}', contact = '{$A['contact']}', email = '{$A['email']}',
                phone = '{$A['phone']}', status = '{$A['status']}',
                postmode = '{$A['postmode']}', enable_reminders = '{$A['rem_status']}',
                owner_id = '{$A['owner_id']}', group_id = '{$A['group_id']}',
                perm_owner = '{$A['perm_owner']}', perm_group = '{$A['perm_group']}',
                perm_members = '{$A['perm_members']}', perm_anon = '{$A['perm_anon']}'
                WHERE id = '{$A['eid']}' LIMIT 1
            ");
            
        } elseif ($A['submission'] == '1') {
            //saving/approving an item from the queue
            
            //need to save the event to events
            DB_query("INSERT INTO {$_TABLES['evlist_events']} SET
                id = '{$A['eid']}',
                title = '{$A['title']}', summary = '{$A['summary']}',
                full_description = '{$A['description']}', date_start1 = '{$A['date_start1']}',
                date_end1 = '{$A['date_end1']}', time_start1 = '{$A['time_start1']}',
                time_end1 = '{$A['time_end1']}', date_start2 = '{$A['date_start2']}',
                date_end2 = '{$A['date_end2']}', time_start2 = '{$A['time_start2']}',
                time_end2 = '{$A['time_end2']}', url = '{$A['url']}', location = '{$A['location']}',
                street = '{$A['street']}', city = '{$A['city']}', province = '{$A['province']}',
                country = '{$A['country']}', postal = '{$A['postal']}', recurring = '{$A['recurring']}',
                rec_option = '{$A['rec_option']}', rec_data = '{$A['rec_data']}', allday = '{$A['allday']}',
                split = '{$A['split']}', contact = '{$A['contact']}', email = '{$A['email']}',
                phone = '{$A['phone']}', status = '{$A['status']}',
                postmode = '{$A['postmode']}', enable_reminders = '{$A['rem_status']}',
                owner_id = '{$A['owner_id']}', group_id = '{$A['group_id']}',
                perm_owner = '{$A['perm_owner']}', perm_group = '{$A['perm_group']}',
                perm_members = '{$A['perm_members']}', perm_anon = '{$A['perm_anon']}'
            ");
            
            //and then delete the event from submissions
            DB_delete($_TABLES['evlist_submissions'], 'id', $A['eid']);
            
        } else {//save new event
            $A['eid'] = COM_makesid();
            $neweid = true;
            
            DB_query("INSERT INTO {$_TABLES['evlist_events']} SET
                id = '{$A['eid']}',
                title = '{$A['title']}', summary = '{$A['summary']}',
                full_description = '{$A['description']}', date_start1 = '{$A['date_start1']}',
                date_end1 = '{$A['date_end1']}', time_start1 = '{$A['time_start1']}',
                time_end1 = '{$A['time_end1']}', date_start2 = '{$A['date_start2']}',
                date_end2 = '{$A['date_end2']}', time_start2 = '{$A['time_start2']}',
                time_end2 = '{$A['time_end2']}', url = '{$A['url']}', location = '{$A['location']}',
                street = '{$A['street']}', city = '{$A['city']}', province = '{$A['province']}',
                country = '{$A['country']}', postal = '{$A['postal']}', recurring = '{$A['recurring']}',
                rec_option = '{$A['rec_option']}', rec_data = '{$A['rec_data']}', allday = '{$A['allday']}',
                split = '{$A['split']}', contact = '{$A['contact']}', email = '{$A['email']}',
                phone = '{$A['phone']}', status = '{$A['status']}',
                postmode = '{$A['postmode']}', enable_reminders = '{$A['rem_status']}',
                owner_id = '{$A['owner_id']}', group_id = '{$A['group_id']}',
                perm_owner = '{$A['perm_owner']}', perm_group = '{$A['perm_group']}',
                perm_members = '{$A['perm_members']}', perm_anon = '{$A['perm_anon']}'
            ");
        }
        
        if (is_array($A['category'])) {
            $A['category'] = array_filter($A['category']);
            $cat_count = count($A['category']);
        }
        
        if ($cat_count >= 1) {
            $i = 1;
            $cat_values = '';
            foreach ($A['category'] AS $key => $cat_id) {
                $cat_id = addslashes (strip_tags (COM_checkWords($cat_id)));
                if (!empty($cat_id)) {
                    $status = '1';
                    if (!is_numeric($cat_id)) {
                        //insert new category
                        DB_query("INSERT INTO {$_TABLES['evlist_categories']} SET name = '$cat_id', status = '$status'");
                        //$newcid = DB_insertID();
                        $newcid = DB_getItem($_TABLES['evlist_categories'], 'id', "name='$cat_id'");
                        if (!empty($newcid)) {
                            $cat_values .= '(' . $A['eid'] . ',' . $newcid . ',' . $status . ')';
                            if ($i < $cat_count) {
                                $cat_values .= ',';
                            }
                        }
                    } else {
                        $cat_values .= '(' . $A['eid'] . ',' . $cat_id . ',' . $status . ')';
                        if ($i < $cat_count) {
                            $cat_values .= ',';
                        }
                    }
                }
                $i++;
            }
            
            //save category info
            if (!empty($cat_values)) {
                if ($neweid) {
                    //inserting categories for a new event
                    DB_query("INSERT IGNORE INTO {$_TABLES['evlist_lookup']} VALUES " . $cat_values);
                } else {
                    //updating categories for an existing event
                    //first delete current entries where eid = $A['eid']
                    DB_delete($_TABLES['evlist_lookup'], 'eid', $A['eid']);
                    DB_query("INSERT IGNORE INTO {$_TABLES['evlist_lookup']} VALUES " . $cat_values);
                }
            }
        } else {
            //uncategorize event if categories have been unassigned
            if (!$neweid) {
                //delete category info for existing eid
                DB_delete($_TABLES['evlist_lookup'], 'eid', $A['eid']);
            }
        }
        
        #if ($A['status'] != '1') {
        #    $retval = COM_refresh ($_CONF['site_url'] . '/evlist/index.php?op=list');
        #} else {
            $retval = COM_refresh ($_CONF['site_url'] . '/evlist/event.php?eid=' . $A['eid']);
        #}
        
        COM_rdfUpToDateCheck ('evlist');
        
    } elseif (($S['allow_anon_add'] == '1' && $_USER['uid'] < 2) || ($_USER['uid'] > 1 && $S['allow_user_add'] == '1')) {
        //submission is going to queue
        
        $A['eid'] = COM_makesid();
        DB_query("INSERT INTO {$_TABLES['evlist_submissions']} SET
            id = '{$A['eid']}',
            title = '{$A['title']}', summary = '{$A['summary']}',
            full_description = '{$A['description']}', date_start1 = '{$A['date_start1']}',
            date_end1 = '{$A['date_end1']}', time_start1 = '{$A['time_start1']}',
            time_end1 = '{$A['time_end1']}', date_start2 = '{$A['date_start2']}',
            date_end2 = '{$A['date_end2']}', time_start2 = '{$A['time_start2']}',
            time_end2 = '{$A['time_end2']}', url = '{$A['url']}', location = '{$A['location']}',
            street = '{$A['street']}', city = '{$A['city']}', province = '{$A['province']}',
            country = '{$A['country']}', postal = '{$A['postal']}', recurring = '{$A['recurring']}',
            rec_option = '{$A['rec_option']}', rec_data = '{$A['rec_data']}', allday = '{$A['allday']}',
            split = '{$A['split']}', contact = '{$A['contact']}', email = '{$A['email']}',
            phone = '{$A['phone']}', status = '{$A['status']}',
            postmode = '{$A['postmode']}', enable_reminders = '{$A['rem_status']}',
            owner_id = '{$A['owner_id']}', group_id = '{$A['group_id']}',
            perm_owner = '{$A['perm_owner']}', perm_group = '{$A['perm_group']}',
            perm_members = '{$A['perm_members']}', perm_anon = '{$A['perm_anon']}'
        ");
        
        if (is_array($A['category'])) {
            $A['category'] = array_filter($A['category']);
            $cat_count = count($A['category']);
        }
        
        if ($cat_count >= 1) {
            $i = 1;
            $cat_values = '';
            foreach ($A['category'] AS $key => $cat_id) {
                $cat_id = COM_applyFilter($cat_id);
                if (!empty($cat_id)) {
                    if (!is_numeric($cat_id) && $_USER['uid'] > 1) {
                        //anon user cannot add new categories,
                        //but logged in members may and for now they are not moderated.
                        //insert new category
                        DB_query("INSERT INTO {$_TABLES['evlist_categories']} SET name = '$cat_id', status = '0'");
                        //$newcid = DB_insertID();
                        $newcid = DB_getItem($_TABLES['evlist_categories'], 'id', "name='$cat_id'");
                        if (!empty($newcid)) {
                            $cat_values .= "('{$A['eid']}','$newcid')";
                            if ($i < $cat_count) {
                                $cat_values .= ',';
                            }
                        }
                    } else {
                        $cat_values .= "('{$A['eid']}','$cat_id')";
                        if ($i < $cat_count) {
                            $cat_values .= ',';
                        }
                    }
                }
                $i++;
            }
            //save category info
            if (!empty($cat_values)) {
                //inserting categories for a new event
                DB_query("INSERT IGNORE INTO {$_TABLES['evlist_lookup']} VALUES " . $cat_values);
            }
        }
        
        if (isset ($_CONF['notification']) && (in_array ('evlist', $_CONF['notification'])
            || in_array('evList', $_CONF['notification']) || in_array('event', $_CONF['notification']))) {
            evlist_sendNotification ($A);
        }
        
        COM_updateSpeedlimit('event');
        
        $retval .= COM_refresh ($_CONF['site_url'] . '/evlist/index.php?msg=9');
    }
    
    return $retval;
}

function evlist_delete_event($eid) {
    global $_CONF, $_TABLES;
    
    DB_delete($_TABLES['evlist_events'], 'id', $eid);//delete the event
    DB_delete($_TABLES['evlist_lookup'], 'eid', $eid);//delete the event from any category
    DB_delete($_TABLES['evlist_remlookup'], 'eid', $eid);//delete associated reminders
    
    $return_page = $_CONF['site_url'] . '/evlist/index.php?op=list&msg=1';
    $retval = COM_refresh($return_page);
    
    return $retval;
}

function evlist_save_reminder($eid, $A) {
    global $_CONF, $_TABLES, $CONF_EVLIST, $LANG_EVLIST01;
    
    //check if speed limit breeched
    COM_clearSpeedlimit ($CONF_EVLIST['reminder_speedlimit'], 'eventrem');
    $last = COM_checkSpeedlimit ('eventrem');
    
    $timestamp = COM_applyFilter($A['timestamp'],true);
    if (empty($timestamp)) {
        $timestamp = '0';
    }
    
    if ($last > 0) {
        $return_page = $_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&ts=' . $timestamp . '&msg=15';
    } else {
        
        $date_start1 = DB_getItem($_TABLES['evlist_events'], 'date_start1', "id='$eid'");
        $date_start1 = strtotime($date_start1);
        
        $email = strip_tags (COM_checkWords ($A['rem_email']));
        if (!COM_isEmail($email)) {
            $return_page = $_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&ts=' . $timestamp . '&msg=13';
            $retval = COM_refresh($return_page);
            return $retval;
        } else {
            $email = addslashes($email);
        }
        
        $notice = COM_applyFilter($A['notice'],true);
        if (empty($notice)) {
            $return_page = $_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&ts=' . $timestamp . '&msg=14';
            $retval = COM_refresh($return_page);
            return $retval;
        }
        
        $id = COM_makesid();
        
        DB_query("INSERT IGNORE INTO {$_TABLES['evlist_remlookup']} SET id = '$id', eid = '$eid',
            date_start = '$date_start1', timestamp = '$timestamp', email = '$email', days_notice = '$notice'");
        
        //update speed limit
        COM_updateSpeedlimit('eventrem');
        
        $return_page = $_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&ts=' . $timestamp . '&msg=12';
    }
    
    $retval = COM_refresh($return_page);
    
    return $retval;
}

/*
 * Main function
 */

if (isset($_POST['eid'])) {
    $eid = COM_sanitizeID($_POST['eid'], false);
} else {
    COM_setArgNames(array('eid','ts','range','cat'));
    $eid = COM_sanitizeID(COM_getArgument('eid'),false);
    $ts = COM_applyFilter(COM_getArgument('ts'),true);
    $range = COM_applyFilter(COM_getArgument('range'),true);
    $cat = COM_applyFilter(COM_getArgument('cat'),true);
}

#if (isset($_REQUEST['eid'])) {
#    $eid = COM_sanitizeID($_REQUEST['eid'], false);
#} else $eid = '';
#
#if (isset($_REQUEST['ts'])) {
#    $ts = COM_applyFilter($_REQUEST['ts']);
#} else $ts = '';
#
#if (isset($_REQUEST['range'])) {
#    $range = COM_applyFilter($_REQUEST['range'], true);
#} else $range = '';

if (isset($_REQUEST['op'])) {
    $op = COM_applyFilter($_REQUEST['op']);
} else $op = '';

if (isset($_REQUEST['msg'])) {
    $msg = COM_applyFilter($_REQUEST['msg'], true);
} else $msg = '';


$display = COM_siteHeader();

if (!empty($msg)) {
    //msg block
    $display .= COM_startBlock($LANG_EVLIST07[6],'','blockheader-message.thtml');
    $display .= $LANG_EVLIST07[$msg];
    $display .= COM_endBlock('blockfooter-message.thtml');
}

if ($_POST['submit'] == $LANG_EVLIST04[7]) { //save event
    //handle sec here
    if (!evlist_check_required_fields($_POST, 'edit')) {
        //missing required field msg
        if (!empty($eid)) {
            print COM_refresh($_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&op=edit&msg=5');
            exit;
        } else {
            print COM_refresh($_CONF['site_url'] . '/evlist/event.php?op=new&msg=5');
            exit;
        }
    } elseif (!evlist_checkdates_simple($_POST)) {
        //start date after end date msg
        if (!empty($eid)) {
            print COM_refresh($_CONF['site_url'] . '/evlist/event.php?eid=' . $eid . '&op=edit&msg=10');
            exit;
        } else {
            print COM_refresh($_CONF['site_url'] . '/evlist/event.php?op=new&msg=10');
            exit;
        }
    } else {
        //write access = 3
        if (!empty($eid) && (evlist_check_perms($eid, '3'))) {//update event
            print evlist_save_event($_POST, $eid);
            exit;
        } else {//create new event
            $result = DB_query("SELECT allow_anon_add, allow_user_add, allow_html FROM {$_TABLES['evlist_settings']}");
            list($allow_anon_add, $allow_user_add, $allow_html) = DB_fetchArray($result);
            if (($_USER['uid'] < 2 && $allow_anon_add == '1') || ($_USER['uid'] > 1 && $allow_user_add == '1') || SEC_hasRights('evlist.edit')) {
                //not denied
                print evlist_save_event($_POST);
                exit;
            } else {
                //denied
                print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
                exit;
            }
        }
    }
} elseif ($_POST['submit'] == $LANG_EVLIST04[9]) { //delete event
    //write access = 3
    if (!empty($eid) && (evlist_check_perms($eid, '3'))) {
        print evlist_delete_event($eid);
        exit;
    } else {
        //denied
        print COM_refresh($_CONF['site_url'] . '/evlist/event.php?eid='. $eid);
        exit;
    }
} elseif ($_POST['submit'] == $LANG_EVLIST04[10]) { //cancel and refresh
    if (!empty($eid)) {
        print COM_refresh($_CONF['site_url'] . '/evlist/event.php?eid='. $eid);
        exit;
    } else {
        print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
        exit;
    }
}

if (!empty($eid)) {

    if (!empty($op) && $_USER['uid'] > 1) {
        //check event perms
        $access = '3';
        if (!evlist_check_perms($eid, $access)) {
            print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
            exit;
        }
        
        if ($op == 'del') {
            //quick delete
            print evlist_delete_event($eid);
            exit;
            
        } elseif ($op == 'edit') {
            //display loaded editor
            $display .= evlist_display_editor($eid);
            
        } elseif ($op == 'editsubmission') {
            //display editor loaded with unapproved submission
            $display .= evlist_display_editor($eid, false, true);
            
        } elseif ($op == 'clone') {
            //clone existing event to editor
            $display .= evlist_display_editor($eid, true);
        }
    } elseif (isset($_POST['reminder'])) {
        if (!evlist_check_perms($eid, '2')) {
            print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
            exit;
        } else {
            print evlist_save_reminder($eid, $_POST);
            exit;
        }
    } else {
        //read access = 2. 2 is default anyway so really not necessary
        if (!evlist_check_perms($eid, '2')) {
            print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
            exit;
        } else {
            //display event
            $display .= evlist_display_event($eid, $ts, $range, $cat);
        }
    }
} elseif (empty($eid) && $op == 'new') {
    //display empty editor
    
    $result = DB_query("SELECT allow_anon_add, allow_user_add FROM {$_TABLES['evlist_settings']}");
    list($allow_anon_add, $allow_user_add) = DB_fetchArray($result);
    
    if (($_USER['uid'] < 2 && $allow_anon_add == '1') || ($_USER['uid'] > 1 && $allow_user_add == '1') || SEC_hasRights('evlist.edit')) {
        $display .= evlist_display_editor();
    } else {
        //illegal access alert
        //just refresh page to index
        print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
        exit;
    }
} else {
    //just refresh page to index
    print COM_refresh($_CONF['site_url'] . '/evlist/index.php?op=list');
    exit;
}

$display .= COM_siteFooter();
echo $display;

?>