<?php
// +-----------------------------------------------------------------------------+
// | evList A calendar solution for Geeklog                                      |
// | Date: Aug, 2007                                                             |
// +-----------------------------------------------------------------------------+
// | mysql_install.php plugin specific SQL                                       |
// +-----------------------------------------------------------------------------+
// | Copyright (C) 2007 by:                                                      |
// | evList Plugin Author:                                                       |
// | Alford Deeley - ajdeeley@summitpages.ca                                     |
// +-----------------------------------------------------------------------------+
// | Geeklog Common Code                                                         |
// | Copyright (C) 2000-2007 by the following authors:                           |
// | Authors: Tony Bibbs        - tony@tonybibbs.com                             |
// |          Mark Limburg      - mlimburg@users.sourceforge.net                 |
// |          Jason Whittenburg - jwhitten@securitygeeks.com                     |
// |          Dirk Haun         - dirk@haun-online.de                            |
// +-----------------------------------------------------------------------------+
// |                                                                             |
// | This program is licensed under the terms of the GNU General Public License  |
// | as published by the Free Software Foundation; either version 2              |
// | of the License, or (at your option) any later version.                      |
// |                                                                             |
// | This program is distributed in the hope that it will be useful,             |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of              |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        |
// | See the GNU General Public License for more details.                        |
// |                                                                             |
// | You should have received a copy of the GNU General Public License           |
// | along with this program; if not, write to the Free Software Foundation,     |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             |
// |                                                                             |
// +-----------------------------------------------------------------------------+


$_SQL[] = "CREATE TABLE {$_TABLES['evlist_events']} (
  id VARCHAR(40) PRIMARY KEY,
  title TINYTEXT,
  summary TEXT,
  full_description TEXT,
  date_start1 DATE,
  date_end1 DATE,
  date_start2 DATE,
  date_end2 DATE,
  time_start1 VARCHAR(8) NOT NULL default '0',
  time_end1 VARCHAR(8),
  time_start2 VARCHAR(8),
  time_end2 VARCHAR(8),
  url VARCHAR(255),
  location TEXT,
  street VARCHAR(64),
  city VARCHAR(64),
  province VARCHAR(64),
  country VARCHAR(64),
  postal VARCHAR(9),
  recurring TINYINT(1) NOT NULL default '0',
  rec_option TINYINT(1),
  rec_data VARCHAR(255),
  allday TINYINT(1) NOT NULL default '0',
  split TINYINT(1) NOT NULL default '0',
  contact VARCHAR(64),
  email VARCHAR(64),
  phone VARCHAR(32),
  status TINYINT(1) NOT NULL default '1',
  postmode VARCHAR(10) NOT NULL default 'plaintext',
  hits INT(11) NOT NULL default '0',
  enable_reminders TINYINT(1) NOT NULL default '1',
  owner_id MEDIUMINT(8),
  group_id MEDIUMINT(8),
  perm_owner TINYINT(1),
  perm_group TINYINT(1),
  perm_members TINYINT(1),
  perm_anon TINYINT(1)
) TYPE=MyISAM";

$_SQL[] = "CREATE TABLE {$_TABLES['evlist_submissions']} (
  id VARCHAR(40) PRIMARY KEY,
  title TINYTEXT,
  summary TEXT,
  full_description TEXT,
  date_start1 DATE,
  date_end1 DATE,
  date_start2 DATE,
  date_end2 DATE,
  time_start1 VARCHAR(8) NOT NULL default '0',
  time_end1 VARCHAR(8),
  time_start2 VARCHAR(8),
  time_end2 VARCHAR(8),
  url VARCHAR(255),
  location TEXT,
  street VARCHAR(64),
  city VARCHAR(64),
  province VARCHAR(64),
  country VARCHAR(64),
  postal VARCHAR(9),
  recurring TINYINT(1) NOT NULL default '0',
  rec_option TINYINT(1),
  rec_data VARCHAR(255),
  allday TINYINT(1) NOT NULL default '0',
  split TINYINT(1) NOT NULL default '0',
  contact VARCHAR(64),
  email VARCHAR(64),
  phone VARCHAR(32),
  status TINYINT(1) NOT NULL default '0',
  postmode VARCHAR(10) NOT NULL default 'plaintext',
  hits INT(11) NOT NULL default '0',
  enable_reminders TINYINT(1) NOT NULL default '0',
  owner_id MEDIUMINT(8),
  group_id MEDIUMINT(8),
  perm_owner TINYINT(1),
  perm_group TINYINT(1),
  perm_members TINYINT(1),
  perm_anon TINYINT(1)
) TYPE=MyISAM";

$_SQL[] = "CREATE TABLE {$_TABLES['evlist_categories']} (
  id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
  name VARCHAR(64),
  status TINYINT(1) NOT NULL default '1',
  UNIQUE Name (Name(10))
) TYPE=MyISAM";

$_SQL[] = "CREATE TABLE {$_TABLES['evlist_lookup']} (
  eid VARCHAR(40) NOT NULL,
  cid INT UNSIGNED NOT NULL,
  status TINYINT(1) NOT NULL default '1',
  PRIMARY KEY(eid,cid)
) TYPE=MyISAM";

$_SQL[] = "CREATE TABLE {$_TABLES['evlist_remlookup']} (
  id VARCHAR(40) NOT NULL,
  eid VARCHAR(40) NOT NULL,
  date_start INT UNSIGNED NOT NULL,
  timestamp INT UNSIGNED,
  email VARCHAR(96) NOT NULL,
  days_notice SMALLINT(3) NOT NULL default '7',
  UNIQUE eid (eid,timestamp,email,days_notice)
) TYPE=MyISAM";

$_SQL[] = "CREATE TABLE {$_TABLES['evlist_dateformat']} (
  id INT NOT NULL PRIMARY KEY,
  format VARCHAR(32)
) TYPE=MyISAM";

$_SQL[] = "CREATE TABLE {$_TABLES['evlist_timeformat']} (
  id INT NOT NULL PRIMARY KEY,
  format VARCHAR(32)
) TYPE=MyISAM";

$_SQL[] = "CREATE TABLE {$_TABLES['evlist_settings']} (
  allow_anon_view TINYINT(1) NOT NULL default '1',
  allow_anon_add TINYINT(1) NOT NULL default '0',
  allow_user_add TINYINT(1) NOT NULL default '0',
  allow_html TINYINT(1) NOT NULL default '1',
  usermenu_option TINYINT(1) NOT NULL default '1',
  enable_menuitem TINYINT(1) NOT NULL default '1',
  week_begins TINYINT(1) NOT NULL default '1',
  date_format TINYINT(2) NOT NULL default '1',
  time_format TINYINT(2) NOT NULL default '1',
  enable_categories TINYINT(1) NOT NULL default '1',
  enable_centerblock TINYINT(1) NOT NULL default '0',
  pos_centerblock TINYINT(1) NOT NULL default '2',
  topic_centerblock VARCHAR(20) NOT NULL default 'home',
  range_centerblock TINYINT(1) NOT NULL default '2',
  limit_centerblock TINYINT(2) NOT NULL default '5',
  limit_list TINYINT(2) NOT NULL default '5',
  limit_block TINYINT(2) NOT NULL default '5',
  limit_summary TINYINT(3) UNSIGNED NOT NULL default '128',
  enable_reminders TINYINT(1) NOT NULL default '1',
  event_passing TINYINT(1) NOT NULL default '2'
) TYPE=MyISAM";

?>